<?php
namespace Geral\Repositories;

use \Setforms2\Shared\Registry;

class Lanccont extends \Doctrine\ORM\EntityRepository
{
    public static function queryCredito($cdempresa, $nrlanccont, $nrorg){
        $sql = "SELECT ROWNUM - 1 AS QTDE, CC.CDCONTREDU, CC.CDCONTCTBL, CC.NMCONTCTBL, ABS(L.VRLANCAMENT) AS VRCREDITO,
                       L.CDHISTPADR, L.CDCONTCOME, L.CDDOCUCONT, L.IDLANCCOME, L.DSHISTLANC
                  FROM LANCCONT L, CONTCTBL CC
                 WHERE L.CDEMPRESA  = :P_CDEMPRESA
                   AND L.NRLANCCONT = :P_NRLANCCONT
                   AND L.NRORG      =  :P_NRORG
                   AND L.CDCONTCTBL = CC.CDCONTCTBL
                   AND L.VRLANCAMENT > 0
                 ORDER BY L.NRLANCCONT, L.NRSEQLANC";
        $paramsWhere = array(
            'P_CDEMPRESA'   => $cdempresa,
            'P_NRLANCCONT'   => $nrlanccont,
            'P_NRORG'   => $nrorg
        );

        try {
            return Registry::getEntityManager()->getConnection()->fetchAll($sql, $paramsWhere);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function queryDebito($cdempresa, $nrlanccont, $nrorg){
        $sql = "SELECT ROWNUM -1  AS QTDE, CC.CDCONTREDU, CC.CDCONTCTBL, CC.NMCONTCTBL, ABS(L.VRLANCAMENT) AS VRDEBITO,
                       L.CDHISTPADR, L.CDCONTCOME, L.CDDOCUCONT, L.IDLANCCOME, L.DSHISTLANC
                  FROM LANCCONT L, CONTCTBL CC
                 WHERE L.CDEMPRESA  = :P_CDEMPRESA
                   AND L.NRLANCCONT = :P_NRLANCCONT
                   AND L.NRORG      =  :P_NRORG
                   AND L.CDCONTCTBL = CC.CDCONTCTBL
                   AND L.VRLANCAMENT < 0
                 ORDER BY L.NRLANCCONT, L.NRSEQLANC";
        $paramsWhere = array(
            'P_CDEMPRESA'   => $cdempresa,
            'P_NRLANCCONT'   => $nrlanccont,
            'P_NRORG'   => $nrorg
        );

        try {
            return Registry::getEntityManager()->getConnection()->fetchAll($sql, $paramsWhere);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}