function SelectMultipleCheckboxController($scope, metaDataFactory) {
	var self = this;

	var checkboxField = {
        name: $scope.$parent.field.name + '_CHECKBOX_ALL',
        label: 'Todos',
        template: 'field/checkbox.html',
        isVisible: true,
        valueToTrue: true,
        valueToFalse: false,
        readOnly: $scope.$parent.field.readOnly,
        events: [
        	{
        		name: 'FieldOnChange',
        		code: checkboxValueChange
        	}
    	]
	};
	
	$scope.field = metaDataFactory.fieldFactory(checkboxField);
	$scope.field.widget = $scope.$parent.field.widget;
	
	var oldFieldValidate = $scope.$parent.field.validate.bind($scope.$parent.field);
	$scope.$parent.field.validate = function(value, callback) {
		value = !Util.isEmptyOrBlank(value) ? value : $scope.field.value();
		oldFieldValidate(value, callback);
	};
	
	function checkboxValueChange() {
		var parentField = $scope.$parent.field;
		parentField.allSelected = $scope.field.value();
		parentField.readOnly = parentField.allSelected;
		parentField.widget.currentRow.$error[parentField.name] = [];
	}
}

ZeedhiFields.directive('zhSelectMultipleCheckbox', function($timeout) {
	return {
		link: function($scope, element) {
			$timeout(function() { $scope.$parent.$parent.field._allCheckboxWidth = $(element).outerWidth(true); }, 100, 0);
		}
	};
});
