package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class CicloPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoCiclo = By.xpath("//section[@class='something-else']//span[text() = 'Ciclo']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoEditar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[1]");
    By botaoIncluir = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");

    By campoCodigo = By.id("CDCARDCICLO");
    By campoNome = By.id("NMCARDCICLO");
    By campoNumeroSemanas = By.id("NRSEMCICLO");
    By campoInicioCiclo = By.xpath("//div[@data-zh-id=\"5540835572114801395571\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By inicioCicloQuarta = By.xpath("//div[@data-zh-id=\"5540835572114801395571\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Quarta']");
    By checkBoxAtivo = By.id("zh-checkbox-IDATIVCICLO");
    By campoCheckBoxAtivo = By.xpath("//label[@for=\"zh-checkbox-IDATIVCICLO\"]/div[1]");

    By botaoExcluirPrimeiroCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]//div[@class=\"zh-grid-actions\"]");
    By nomePrimeiroCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    By botaoExcluirSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]//div[@class=\"zh-grid-actions\"]");
    By codigoSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By nomeSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]/div[3]/span");
    By numeroSemanasSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]/div[4]/span");
    By numeroCardapiosSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]/div[5]/span");
    By inicioSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]/div[6]/span");
    By ativoSegundoCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[2]/div[7]//span[@class=\"inline-checkbox zh-ripple-effect checked\"]");

    By padraoCicloVendas = By.xpath("//div[@id=\"grid-5540835572610232968501\"]//div[@data-zh-field-name=\"NMPADCICLO\"]//span[text() = 'VENDAS']");
    By checkBoxPadraoCiclo = By.xpath("//div[@id=\"grid-554083557159926467500\"]//div[@class=\"body-content\"]/div[1]/div[1]//span[@data-ng-if=\"!row.__group\"]");
    By nomePadraoCiclo = By.xpath("//div[@id=\"grid-554083557159926467500\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By tipoPratoArroz = By.xpath("//div[@id=\"grid-5540835574033265492510\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By tipoPratoSalada = By.xpath("//div[@id=\"grid-5540835574033265492510\"]//div[@class=\"body-content\"]/div[3]/div[1]");

    By botaoExluirPrimTipoPratPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By tipoPratoPrimPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By complementoPrimTipoPratPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By opcaoPrimTipoPratPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[4]/div[1]");
    By opcaoPrimTipoPraAtivada = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[4]//span[@class=\"inline-checkbox zh-ripple-effect checked\"]");

    By tipoPratoSegPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By abaCiclo = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Ciclo']");

    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"5540835572123934878563\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"5540835574060717102567\"]//div[@class=\"zh-validation\"]/span");


    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Ciclo");
        click(selecionarOpcaoCiclo);
    }

    public void adicionarCiclo() {
        click(botaoAdicionar);
        sendKeys(campoCodigo, "5");
        sendKeys(campoNome, "ENTREGA");
        clearAndSendKeys(campoNumeroSemanas, "3");
        click(campoInicioCiclo);
        clicarCampoSelecionarValor(campoInicioCiclo, inicioCicloQuarta);
        click(botaoSalvar);
    }

    public void verificarCicloAdicionado() {
        tempo();
        tempo();
        click(botaoVoltar);
        tempo();
        //valores encontrados
        String encCodigo = getText(codigoSegundoCiclo);
        String encNome = getText(nomeSegundoCiclo);
        String encNumeroSemanas = getText(numeroSemanasSegundoCiclo);
        String encNumeroCardapios = getText(numeroCardapiosSegundoCiclo);
        String encInicioCiclo = getText(inicioSegundoCiclo);
        boolean encAtivo = returnIfElementExists(ativoSegundoCiclo);

        //valores esperados
        String expCodigo = "00005";
        String expNome = "ENTREGA";
        String expNumeroSemanas = "3";
        String expNumeroCardapios = "21";
        String expInicioCiclo = "Quarta";
        boolean expAtivo = true;

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do ciclo adicionado");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do ciclo adicionado");
        Assert.assertEquals(encNumeroSemanas, expNumeroSemanas, "Verificação do número de semanas do ciclo adicionado");
        Assert.assertEquals(encNumeroCardapios, expNumeroCardapios, "Verificação do número de cardápios do ciclo adicionado");
        Assert.assertEquals(encInicioCiclo, expInicioCiclo, "Verificação do início do ciclo adicionado");
        Assert.assertEquals(encAtivo, expAtivo, "Verificação se o ciclo adicionado está ativo ou não");

    }

    public void editarNomeCiclo() {
        tempo();
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(nomeSegundoCiclo)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys("ENTREGA RÁPIDA").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvar);

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso apresentada após adicionar um padrão de ciclo.");

        String nome = getText(nomeSegundoCiclo);
        String nomeEsperado = "ENTREGA RÁPIDA";
        Assert.assertEquals(nome, nomeEsperado, "Verificação do nome do ciclo após a edição");
    }

    public void excluirCicloAdicionado() {
        tempo();
        click(botaoExcluirSegundoCiclo);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão excluir");
        click(botaoSim);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso, após excluir o padrão de ciclo");
    }

    public void adicionarPadraoCiclo() {
        tempo();
        click(codigoSegundoCiclo);
        tempo();
        click(botaoAdicionar);
        click(padraoCicloVendas);
        click(tipoPratoArroz);
        click(tipoPratoSalada);
        click(botaoIncluir);

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Registro adicionado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso apresentada após adicionar um padrão de ciclo.");
        tempo();

        //valores encontrados
        String nomePrimeiroTipoPrato = getText(tipoPratoPrimPadrCiclo);
        String nomeSegundoTipoPrato = getText(tipoPratoSegPadrCiclo);

        //valores esperados
        String expPrimeiroTipoPrato = "ARROZ";
        String expSegundoTipoPrato = "SALADA";

        Assert.assertEquals(nomePrimeiroTipoPrato, expPrimeiroTipoPrato, "Verificação do primeiro tipo prato, adicionado na padrão ciclo");
        Assert.assertEquals(nomeSegundoTipoPrato, expSegundoTipoPrato, "Verificação do segundo tipo prato, adicionado na padrão ciclo");

        click(botaoVoltar);
        String encNomePadraoCiclo = getText(nomePadraoCiclo);
        String expNomePadraoCiclo = "VENDAS";
        Assert.assertEquals(encNomePadraoCiclo, expNomePadraoCiclo, "Verificação do nome do padrão ciclo adicionado");
    }

    public void ativarOpcaoPrimeiroTipPratPadrCiclo() {
        tempo();
        click(nomePadraoCiclo);
        //valor encontrado
        boolean encOpcao = returnIfElementExists(opcaoPrimTipoPraAtivada);
        Assert.assertEquals(encOpcao, false, "Verificação se a opção do primeiro tipo de prato, já está ativada após adicionar o padrão ciclo");

        click(opcaoPrimTipoPratPadrCiclo);
        click(botaoSalvar);
        encOpcao = returnIfElementExists(opcaoPrimTipoPraAtivada);
        Assert.assertEquals(encOpcao, true, "Verificação se a opção do primeiro tipo de prato, está ativada após clicar no icone da opção");
    }

    public void adicionarEEditarComplemento() {
        tempo();
        tempo();
        tempo();
        tempo();


        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(complementoPrimTipoPratPadrCiclo)).click().build().perform();
        tempo();
        actions.sendKeys("Automação").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvar);
        verificarComplemento("Automação", "adicionar");

        actions.moveToElement(driver.findElement(complementoPrimTipoPratPadrCiclo)).click().build().perform();
        tempo();
        actions.sendKeys("Editar Auto").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvar);
        verificarComplemento("Editar Auto", "editar");

        actions.moveToElement(driver.findElement(complementoPrimTipoPratPadrCiclo)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvar);
        verificarComplemento("", "apagar");
    }

    private void verificarComplemento(String complementoEsperado, String verificarAposAcao) {
        tempo();
        String complemento = getText(complementoPrimTipoPratPadrCiclo);
        Assert.assertEquals(complemento, complementoEsperado, "Verificação do valor do campo complemento após " + verificarAposAcao + " o mesmo");
        tempo();
    }

    public void excluirTipoPratoPadrCiclo() {
        tempo();
        tempo();
        for (int x=1; x <= 2; x++) {
            click(botaoExluirPrimTipoPratPadrCiclo);
            String mensagem = getText(mensagemAlerta);
            String mensagemEsperada = "Deletar o registro?";
            Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão para excluir o tipo de prato do padrão ciclo");
            click(botaoSim);

            if (x == 1) {
                mensagem = getText(mensagemSucesso);
                mensagemEsperada = "Excluído com sucesso!";
                Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso, após excluir o padrão de ciclo");
                tempo();
                tempo();
            }
        }
        tempo();
        click(botaoVoltar);
    }

    public void tentarExcluirCicloComRegFilho() {
        tempo();
        click(botaoExcluirPrimeiroCiclo);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão para excluir o tipo de prato do padrão ciclo");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após tentar excluir um ciclo que possui registro filho");
        click(botaoOk);

        String nomeCiclo = getText(nomePrimeiroCiclo);
        String nomeEsperado = "RETIRADA";
        Assert.assertEquals(nomeCiclo, nomeEsperado, "Verificação se o ciclo que possui registro filho não foi excluído");
    }

    public void tentarExcluirPadraoCicloComRegFilho() {
        click(checkBoxPadraoCiclo);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão para excluir o tipo de prato do padrão ciclo");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após tentar excluir um ciclo que possui registro filho");
        click(botaoOk);
        click(checkBoxPadraoCiclo);

        String encNomePadraoCiclo = getText(nomePadraoCiclo);
        String expNomePadraoCiclo = "VENDAS";
        Assert.assertEquals(encNomePadraoCiclo, expNomePadraoCiclo, "Verificação se o padrão ciclo não foi excluir após a tentativa de excluir com registros filhos");
    }

    public void campoObrigatoriosFormAddCiclo() {
        click(botaoAdicionar);
        click(botaoSalvar);

        String codigo = getText(mensagemObrigatorioCodigo);
        String nome = getText(mensagemObrigatorioNome);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo código");
        Assert.assertEquals(nome, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo nome");
        click(botaoCancelar);
    }

    public void verificarOpcaoAtivoCiclo() {
        tempo();
        click(abaCiclo);
        click(botaoEditar);

        boolean chechBoxCiclo = returnIfElementIsSelected(checkBoxAtivo);
        Assert.assertEquals(chechBoxCiclo, true, "Verificação se por padrão o ciclo vem com a opção 'ativo' selecionada");
        click(campoCheckBoxAtivo);
        click(botaoSalvar);
        tempo();
        click(abaCiclo);
        click(botaoEditar);

        chechBoxCiclo = returnIfElementIsSelected(checkBoxAtivo);
        Assert.assertEquals(chechBoxCiclo, false, "Verificação se após clicar no check-box ativo e salvar, o ciclo não está mais ativo");
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void tentarAddCicloCodRepetido() {
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNome, "ENTREGA");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela, após tentar adicionar um ciclo com código existente");
        click(botaoOk);
        click(botaoCancelar);
    }

}
