package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class PratoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoPrato = By.xpath("//section[@class='something-else']//span[text() = 'Prato']");

    By botaoMenuOpcoesTelaPrato = By.xpath("//div[@class=\"zh-floating-control pos-bottom pos-right ui-draggable ui-draggable-handle\"]");
    By botaoPesquisarPrato = By.xpath("//div[@class=\"zh-floating-control pos-bottom pos-right ui-draggable ui-draggable-handle opened\"]//li[@class=\"float-action expandable\"]");
    By pratoSaladaAlface = By.xpath("//div[@id=\"grid-1378085694698904621727\"]//span[text() = 'SALADA DE ALFACE']");

    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");

    By primeiroCampoArvore = By.xpath("//div[@id=\"grid-1378085694698904621727\"]//div[@class=\"tree-body-content\"]/div[1]//span[@data-zh-icon=\"forward no-border\"]");
    By segundoCampoArvore = By.xpath("//div[@id=\"grid-1378085694698904621727\"]//div[@class=\"tree-body-content\"]/div[2]//span[@data-zh-icon=\"forward no-border\"]");
    By terceiroCampoArovore = By.xpath("//div[@id=\"grid-1378085694698904621727\"]//div[@class=\"tree-body-content\"]/div[3]//span[@data-zh-icon=\"forward no-border\"]");

    By pratoFeijoadaMagra = By.xpath("//div[@id=\"grid-1378085694698904621727\"]//span[text() = 'FEIJOADA MAGRA']");
    By abaReceita = By.xpath("//section[@data-zh-id=\"13780856943996409796728\"]//a[text() = 'Receita']");
    By abaModoPreparo = By.xpath("//section[@data-zh-id=\"13780856943996409796728\"]//a[text() = 'Modo de Preparo']");
    By receitaPadrao = By.xpath("//section[@class=\"zh-widget\"]//div[@class=\"body-content\"]//span[text() = 'Receita Padrão']");
    By receitaLocal = By.xpath("//section[@class=\"zh-widget\"]//div[@class=\"body-content\"]//span[text() = 'Receita Local']");
    By receitaServico = By.xpath("//section[@class=\"zh-widget\"]//div[@class=\"body-content\"]//span[text() = 'Receita Serviço']");
    By receitaPadraoQualidade = By.xpath("//section[@class=\"zh-widget\"]//div[@class=\"body-content\"]//span[text() = 'Receita Padrão de Qualidade']");
    By receitaRegiao = By.xpath("//section[@class=\"zh-widget\"]//div[@class=\"body-content\"]//span[text() = 'Receita Região']");

    By campoProduto = By.id("NMPRODUTO");
    By botaoCampoProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By produtoCarum = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARUM CARVI (FRUTO)']");
    By produtoProducaoArnica = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'ARNICA MONTANA 6CH']");
    By produtoQuerosene = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'QUEROSENE']");
    By produtoBryonia = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'BRYONIA ALBA TM']");
    By produtoBarataOriental = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'BARATA ORIENTAL']");
    By campoUnidade = By.id("SGUNIDADEPROD");

    By abaProdutosDaReceitaPadrao = By.xpath("//section[@data-zh-id=\"13780856941870927771796\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos da Receita']");
    By abaDadosDaReceitaPadrao = By.xpath("//section[@data-zh-id=\"13780856941870927771796\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Dados da Receita']");
    By botaoCalcularReceitaPadrao = By.xpath("//div[@data-zh-id=\"13780856943470839049900\"]/button");
    By campoQuantBrutaPadrao = By.id("QTBRUTAPRUNR");
    By campoQuantidadePadrao = By.id("QTPRODPRAT");
    By campoQuantRequeridaPadrao = By.id("QTBRUTAPR");
    By campoGanhoCoccaoPadrao = By.id("VRPEFATCOCPR");
    By campoApCoccaoPadrao = By.id("VRPEFATCOCPRAP");
    By campoQuantFixaPadrao = By.xpath("//div[@data-zh-id=\"13780856943979449840819\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By quantFixaSimPadrao = By.xpath("//div[@data-zh-id=\"13780856943979449840819\"]//li[text() = 'Sim']");
    By quantFixaNaoPadrao = By.xpath("//div[@data-zh-id=\"13780856943979449840819\"]//li[text() = 'Não']");
    By campoPerdaLimpezaPadrao = By.id("VRPEFATCORPR");
    By campoApLimpezaPadrao = By.id("VRPEFATCORPRAP");
    By campoDegeloPadrao = By.id("VRPERCDEGELO");
    By campoReqParaPadrao = By.xpath("//div[@data-zh-id=\"13780856943030116969833\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By reqParaProducaoPadrao = By.xpath("//div[@data-zh-id=\"13780856943030116969833\"]//li[text() = 'Produção']");
    By reqParaDistribuicaoPadrao = By.xpath("//div[@data-zh-id=\"13780856943030116969833\"]//li[text() = 'Distribuição']");
    By reqParaEntregaDiretaPadrao = By.xpath("//div[@data-zh-id=\"13780856943030116969833\"]//li[text() = 'Entrega Direta']");
    By campoComplementoPadrao = By.id("QTCOMPLPRODPADR");
    By campoCompleEntregaDirPadrao = By.xpath("//div[@data-zh-id=\"13780856942160705813835\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By compleEntregaDiretaSimPadrao = By.xpath("//div[@data-zh-id=\"13780856942160705813835\"]//li[text() = 'Sim']");
    By compleEntregaDiretaNaoPadrao = By.xpath("//div[@data-zh-id=\"13780856942160705813835\"]//li[text() = 'Não']");
    By campoTempoPadrao = By.id("HRTEMPPREPPR");
    By campoPrBasePadrao = By.xpath("//div[@data-zh-id=\"1378085694452204633837\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By prBaseSimPadrao = By.xpath("//div[@data-zh-id=\"1378085694452204633837\"]//li[text() = 'Sim']");
    By prBaseNaoPadrao = By.xpath("//div[@data-zh-id=\"1378085694452204633837\"]//li[text() = 'Não']");
    By campoDiasLimSegPadrao = By.id("QTLIMSEGPADR");
    By campoBaseCalcNutrientePadrao = By.id("BASENUTR");
    By campoApNutricionalPadrao = By.id("VRPEFATNUTPR");
    By campoQuantCalcNutrientePadrao = By.id("QTCALCNUTRPR");
    By mensagemObrigatorioProdutoPadrao = By.xpath("//div[@data-zh-id=\"1378085694847161473803\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadePadrao = By.xpath("//div[@data-zh-id=\"13780856944032959538808\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadePadrao = By.xpath("//div[@data-zh-id=\"13780856943357667906820\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantBrutaPadrao = By.xpath("//div[@data-zh-id=\"13780856942754480465822\"]//div[@class=\"zh-validation\"]/span");
    By campoQuantidadePessoaPadrao = By.id("QTPADRAOPRAT");
    By campoFinalizacaoPadrao = By.xpath("//div[@data-zh-id=\"13780856944094074503890\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By finalizacaoUnidadePadrao = By.xpath("//div[@data-zh-id=\"13780856944094074503890\"]//li[text() = 'Unidade']");
    By finalizacaoMatrizPadrao = By.xpath("//div[@data-zh-id=\"13780856944094074503890\"]//li[text() = 'Matriz']");
    By campoNomeFantasiaPadrao = By.id("NMFANTASIAPR");
    By campoStatusDadosReceitaPadrao = By.xpath("//div[@data-zh-id=\"13780856942325171073902\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoDadosReceitaPadrao = By.xpath("//div[@data-zh-id=\"13780856942325171073902\"]//li[text() = 'Ativo']");
    By statusInativoDadosReceitaPadrao = By.xpath("//div[@data-zh-id=\"13780856942325171073902\"]//li[text() = 'Inativo']");
    By campoDataInativacaoAutoPadrao = By.id("DTINATIVAUTO");
    By botaoDataInativacaoPadrao = By.xpath("//div[@data-zh-id=\"137808569426239623901134\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoMedidaCaseiraDadosReceitaPadrao = By.id("NMMEDICASE");
    By medidaXicaraChaDadosReceitaPadrao = By.xpath("//div[@data-zh-id=\"13780856942460682559999\"]//span[text() = '00002 | XÍCARA DE CHÁ']");
    By botaoMedidaCaseiraDadosReceitaPadrao = By.xpath("//div[@data-zh-id=\"13780856942460682559999\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoQuantidadeDadosReceitaPadrao = By.id("QTMEDICASEPRATPADR");
    By campoDescricaoPratoDadosReceitaPadrao = By.id("DSPRATO");
    By campoQuantidadeContainerDadosReceitaPadrao = By.id("QTCONTAIPRAT");
    By campoMinimoContainerPadrao = By.id("VRPEMINPADR");
    By campoAmostraPadrao = By.id("QTAMOSTRPADR");

    By abaProdutosDaReceitaLocal = By.xpath("//section[@data-zh-id=\"1378085694408339710942\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos da Receita']");
    By abaDadosDaReceitaLocal = By.xpath("//section[@data-zh-id=\"1378085694408339710942\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Dados da Receita']");
    By botaoCalcularReceitaLocal = By.xpath("//div[@data-zh-id=\"13780856943064813501048\"]/button");
    By campoQuantidadeLocal = By.id("QTPRODRECLOC");
    By campoQuantBrutaLocal = By.id("QTBRUTALOUNR");
    By campoQuantRequeridaLocal = By.id("QTBRUTALO");
    By campoGanhoCoccaoLocal = By.id("VRPEFATCOCLO");
    By campoApCoccaoLocal = By.id("VRPEFATCOCLOAP");
    By campoQuantFixaLocal = By.xpath("//div[@data-zh-id=\"13780856942105682773966\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By quantiFixSimLocal = By.xpath("//div[@data-zh-id=\"13780856942105682773966\"]//li[text() = 'Sim']");
    By campoPerdaLimpezaLocal = By.id("VRPEFATCORLO");
    By campoApLimpezaLocal = By.id("VRPEFATCORLOAP");
    By campoDegeloLocal = By.id("VRPERCDEGELO");
    By campoReqParaLocal = By.xpath("//div[@data-zh-id=\"13780856941943103655980\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By reqParaDistribuicaoLocal = By.xpath("//div[@data-zh-id=\"13780856941943103655980\"]//li[text() = 'Distribuição']");
    By campoCompleEntregaDirLocal = By.xpath("//div[@data-zh-id=\"13780856944284943343982\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By compleEntrefaDirSimLocal = By.xpath("//div[@data-zh-id=\"13780856944284943343982\"]//li[text() = 'Sim']");
    By campoComplementoLocal = By.id("QTCOMPLPRODFILI");
    By campoTempoLocal = By.id("HRTEMPPREPLO");
    By campoPrBaseLocal = By.xpath("//div[@data-zh-id=\"13780856942154187268984\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By prBaseSimLocal = By.xpath("//div[@data-zh-id=\"13780856942154187268984\"]//li[text() = 'Sim']");
    By campoDiaLimSegLocal = By.id("QTLIMSEGFILI");
    By campoBaseCalcNutrienteLocal = By.id("BASENUTR");
    By campoApNutricionalLocal = By.id("VRPEFATNUTLO");
    By campoQuantCalcNutrienteLocal = By.id("QTCALCNUTRLO");
    By mensagemObrigatorioProdutoLocal = By.xpath("//div[@data-zh-id=\"1378085694134573733392\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeLocal = By.xpath("//div[@data-zh-id=\"13780856942910223375955\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeLocal = By.xpath("//div[@data-zh-id=\"13780856942458963920967\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantBrutaLocal = By.xpath("//div[@data-zh-id=\"1378085694147591803969\"]//div[@class=\"zh-validation\"]/span");
    By campoQuantidadePessoaLocal = By.id("QTPADRAOFILI");
    By campoFinalizacaoLocal = By.xpath("//div[@data-zh-id=\"137808569440559525961038\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By finalizacaoUnidadeLocal = By.xpath("//div[@data-zh-id=\"137808569440559525961038\"]//li[text() = 'Unidade']");
    By finalizacaoMatrizLocal = By.xpath("//div[@data-zh-id=\"137808569440559525961038\"]//li[text() = 'Matriz']");
    By campoNomeFantasiaLocal = By.id("NMFANTASIAPF");
    By campoStatusDadosReceitaLocal = By.xpath("//div[@data-zh-id=\"137808569430136696971050\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusInativoDadosReceitaLocal = By.xpath("//div[@data-zh-id=\"137808569430136696971050\"]//li[text() = 'Inativo']");
    By statusAtivoDadosReceitaLocal = By.xpath("//div[@data-zh-id=\"137808569430136696971050\"]//li[text() = 'Ativo']");
    By campoDataInativacaoAutoLocal = By.id("DTINATIVAUTO");
    By botaoDataInativacaoLocal = By.xpath("//div[@data-zh-id=\"137808569441821995981135\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoMedidaCaseiraDadosReceitaLocal = By.id("NMMEDICASE");
    By medidaXicaraChaDadosReceitaLocal = By.xpath("//div[@data-zh-id=\"137808569440616319331005\"]//span[text() = '00002 | XÍCARA DE CHÁ']");
    By botaoMedidaCaseiraDadosReceitaLocal = By.xpath("//div[@data-zh-id=\"137808569440616319331005\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoQuantidadeDadosReceitaLocal = By.id("QTMEDICASEPRATFILI");
    By campoDescricaoPratoDadosReceitaLocal = By.id("DSPRATO");
    By campoQuantidadeContainerDadosReceitaLocal = By.id("QTCONTAIFILI");
    By campoMinimoContainerLocal = By.id("VRPEMINFILI");
    By campoAmostraLocal = By.id("QTAMOSTRFILI");

    By abaProdutosDaReceitaServico = By.xpath("//section[@data-zh-id=\"137808569431711409981095\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos da Receita']");
    By abaDadosDaReceitaServico = By.xpath("//section[@data-zh-id=\"137808569431711409981095\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Dados da Receita']");
    By botaoCalcularReceitaServico = By.xpath("//div[@data-zh-id=\"13780856947433012891203\"]/button");
    By campoQuantBrutaServico = By.id("QTBRUTASEUNR");
    By campoQuantidadeServico = By.id("QTPRODRECSER");
    By campoQuantRequeridaServico = By.id("QTBRUTASE");
    By campoQuantFixaServico = By.xpath("//div[@data-zh-id=\"137808569415012922381120\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By quantFixaSimServico = By.xpath("//div[@data-zh-id=\"137808569415012922381120\"]//li[text() = 'Sim']");
    By quantFixaNaoServico = By.xpath("//div[@data-zh-id=\"137808569415012922381120\"]//li[text() = 'Não']");
    By campoGanhoCoccaoServico = By.id("VRPEFATCOCSE");
    By campoApCoccaoServico = By.id("VRPEFATCOCSEAP");
    By campoPerdaLimpezaServico = By.id("VRPEFATCORSE");
    By campoApLimpezaServico = By.id("VRPEFATCORSEAP");
    By campoDegeloServico = By.id("VRPERCDEGELO");
    By campoReqParaServico = By.xpath("//div[@data-zh-id=\"13780856949721524991134\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By reqParaDistribuicaoServico = By.xpath("//div[@data-zh-id=\"13780856949721524991134\"]//li[text() = 'Distribuição']");
    By reqParaProducaoServico = By.xpath("//div[@data-zh-id=\"13780856949721524991134\"]//li[text() = 'Produção']");
    By reqparaEntregaDiretaServico = By.xpath("//div[@data-zh-id=\"13780856949721524991134\"]//li[text() = 'Entrega Direta']");
    By campoComplementoServico = By.id("QTCOMPLPRODSERV");
    By campoCompleEntregaDiretaServico = By.xpath("//div[@data-zh-id=\"13780856944654119381136\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By compleEntregaDiretaSimServico = By.xpath("//div[@data-zh-id=\"13780856944654119381136\"]//li[text() = 'Sim']");
    By compleEntregaDiretaNaoServico = By.xpath("//div[@data-zh-id=\"13780856944654119381136\"]//li[text() = 'Não']");
    By campoTempoServico = By.id("HRTEMPPREPSE");
    By campoPrBaseServico = By.xpath("//div[@data-zh-id=\"137808569438639427591138\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By prBaseSimServico = By.xpath("//div[@data-zh-id=\"137808569438639427591138\"]//li[text() = 'Sim']");
    By prBaseNaoServico = By.xpath("//div[@data-zh-id=\"137808569438639427591138\"]//li[text() = 'Não']");
    By campoDiaLimSegServico = By.id("QTLIMSEGSERV");
    By campoBaseCalcNutrienteServico = By.id("BASENUTR");
    By campoApNutricionalServico = By.id("VRPEFATNUTSE");
    By quantCalculoNutrienteServico = By.id("QTCALCNUTRSE");
    By mensagemObrigatorioProdutoServico = By.xpath("//div[@data-zh-id=\"137808569428594396871104\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeServico = By.xpath("//div[@data-zh-id=\"137808569426505356281109\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeServico = By.xpath("//div[@data-zh-id=\"137808569432220999001121\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantBrutaServico = By.xpath("//div[@data-zh-id=\"137808569432925801201123\"]//div[@class=\"zh-validation\"]/span");
    By campoQuantidadePessoaServico = By.id("QTPADRAOSERV");
    By campoFinalizacaoServico = By.xpath("//div[@data-zh-id=\"137808569433103648141193\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By finalizacaoUnidadeServico = By.xpath("//div[@data-zh-id=\"137808569433103648141193\"]//li[text() = 'Unidade']");
    By finalizacaoMatrizServico = By.xpath("//div[@data-zh-id=\"137808569433103648141193\"]//li[text() = 'Matriz']");
    By campoNomeFantasiaServico = By.id("NMFANTASIASE");
    By campoStatusDadosReceitaServico = By.xpath("//div[@data-zh-id=\"137808569418843309621205\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoDadosReceitaServico = By.xpath("//div[@data-zh-id=\"137808569418843309621205\"]//li[text() = 'Ativo']");
    By statusInativoDadosReceitaServico = By.xpath("//div[@data-zh-id=\"137808569418843309621205\"]//li[text() = 'Inativo']");
    By campoDataInativacaoAutoServico = By.id("DTINATIVAUTO");
    By botaoDataInativacaoServico = By.xpath("//div[@data-zh-id=\"137808569412036742931136\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoMedidaCaseiraDadosReceitaServico = By.id("NMMEDICASE");
    By medidaXicaraChaDadosReceitaServico = By.xpath("//div[@data-zh-id=\"137808569428205947431011\"]//span[text() = '00002 | XÍCARA DE CHÁ']");
    By botaoMedidaCaseiraDadosReceitaServico = By.xpath("//div[@data-zh-id=\"137808569428205947431011\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoQuantidadeDadosReceitaServico = By.id("QTMEDICASEPRATSERV");
    By campoDescricaoPratoDadosReceitaServico = By.id("DSPRATO");
    By campoQuantidadeContainerDadosReceitaServico = By.id("QTCONTAISERV");
    By campoMinimoContainerServico = By.id("VRPEMINSERV");
    By campoAmostraServico = By.id("QTAMOSTRSERV");

    By abaProdutosDaReceitaPadraoQualidade = By.xpath("//section[@data-zh-id=\"137808569441298516201256\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos da Receita']");
    By abaDadosDaReceitaPadraoQualidade = By.xpath("//section[@data-zh-id=\"137808569441298516201256\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Dados da Receita']");
    By botaoCalcularReceitaPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569431083370361316\"]/button");
    By campoQuantBrutaPadraoQualidade = By.id("QTBRUTAPADQUNR");
    By campoQuantFixaPadraQualidade = By.xpath("//div[@data-zh-id=\"13780856946217453711274\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By quantFixaSimPadraoQualidade = By.xpath("//div[@data-zh-id=\"13780856946217453711274\"]//li[text() = 'Sim']");
    By quantFixaNaoPadraoQualidade = By.xpath("//div[@data-zh-id=\"13780856946217453711274\"]//li[text() = 'Não']");
    By campoPrBasePadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569442271623141287\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By prBaseSimPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569442271623141287\"]//li[text() = 'Sim']");
    By prBaseNaoPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569442271623141287\"]//li[text() = 'Não']");
    By campoGanhoCoccaoPadraoQualidade = By.id("VRPEFATCOCPADQ");
    By campoApCoccaoPadraoQualidade = By.id("VRPEFATCOCLOAP");
    By campoPerdaLimpezaPadraoQualidade = By.id("VRPEFATCORPADQ");
    By campoApLimpezaPadraoQualidade = By.id("VRPEFATCORLOAP");
    By mensagemObrigatorioProdutoPadraoQualidade = By.xpath("//div[@data-zh-id=\"13780856947711183811263\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadePadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569427525713881268\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadePadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569414645318051275\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantBrutaPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569419440899461277\"]//div[@class=\"zh-validation\"]/span");
    By campoQuantidadePessoaPadraoQualidade = By.id("QTPADRAOPADQ");
    By campoDataInativacaoAutoPadraoQualidade = By.id("DTINATIVAUTO");
    By botaoDataInativacaoPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569416967355281137\"]//span[@style=\"background-image: none; display: block;\"]");

    By abaProdutosDaReceitaRegiao = By.xpath("//section[@data-zh-id=\"137808569412291115141338\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos da Receita']");
    By abaDadosDaReceitaRegiao = By.xpath("//section[@data-zh-id=\"137808569412291115141338\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Dados da Receita']");
    By botaoCalcularReceitaRegiao = By.xpath("//div[@data-zh-id=\"13780856947787295811399\"]/button");
    By campoQuantidadeRegiao = By.id("QTPRODRECREGIAO");
    By campoQuantBrutaRegiao = By.id("QTBRUTAREGIAOUNR");
    By campoQuantFixaRegiao = By.xpath("//div[@data-zh-id=\"13780856942190743801355\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By quantFixaSimRegiao = By.xpath("//div[@data-zh-id=\"13780856942190743801355\"]//li[text() = 'Sim']");
    By quantFixaNaoRegiao = By.xpath("//div[@data-zh-id=\"13780856942190743801355\"]//li[text() = 'Não']");
    By campoPrbaseRegiao = By.xpath("//div[@data-zh-id=\"137808569440295617081356\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By prBaseSimRegiao = By.xpath("//div[@data-zh-id=\"137808569440295617081356\"]//li[text() = 'Sim']");
    By prBaseNaoRegiao = By.xpath("//div[@data-zh-id=\"137808569440295617081356\"]//li[text() = 'Não']");
    By campoGanhoCoccaoRegiao = By.id("VRPEFATCOCREGIAO");
    By campoApCoccaoRegiao = By.id("VRPEFATCOCLOAP");
    By campoPerdaLimpezaRegiao = By.id("VRPEFATCORREGIAO");
    By campoApLimpezaCoccaoRegiao = By.id("VRPEFATCORLOAP");
    By mensagemObrigatorioProdutoRegiao = By.xpath("//div[@data-zh-id=\"137808569433270382091345\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeRegiao = By.xpath("//div[@data-zh-id=\"137808569415201222301349\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeRegiao = By.xpath("//div[@data-zh-id=\"137808569428752162031357\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantBrutaRegiao = By.xpath("//div[@data-zh-id=\"137808569413447010941359\"]//div[@class=\"zh-validation\"]/span");
    By campoQuantidadePessoaRegiao = By.id("QTPADRAOREGIAO");
    By campoDataInativacaoAutoRegiao = By.id("DTINATIVAUTO");
    By botaoDataInativacaoRegiao = By.xpath("//div[@data-zh-id=\"13780856947310543941138\"]//span[@style=\"background-image: none; display: block;\"]");

    //selecionar a receita e modo de preparo
    By campoServico = By.id("NMSERVICO");
    By servicoJantaReceitaServico = By.xpath("//div[@data-zh-id=\"137808569423005609441250\"]//span[text() = '00002 | JANTA']");
    By servicoJantaModoPreparo = By.xpath("//div[@data-zh-id=\"137808569427605554981514\"]//span[text() = '00002 | JANTA']");

    By campoPadraoQualidade = By.id("NMPADRAOQUALIDADE");
    By padraoQualidadeExcelenteReceita = By.xpath("//div[@data-zh-id=\"137808569433558383321334\"]//span[text() = '00001 | EXCELENTE']");
    By padraoQualidadeExcelenteModoPreparo = By.xpath("//div[@data-zh-id=\"137808569411671222651542\"]//span[text() = '00001 | EXCELENTE']");
    By regionalQualidadeExcelenteReceita = By.xpath("//div[@data-zh-id=\"137808569430997759741421\"]//span[text() = '00001 | EXCELENTE']");

    By campoRegiao = By.id("NMREGIAO");
    By regiaoBeloHorizonteReceita = By.xpath("//div[@data-zh-id=\"137808569418433223061425\"]//span[text() = '002 | BELO HORIZONTE']");
    By regiaoBeloHorizonteModoPreparo = By.xpath("//div[@data-zh-id=\"137808569424689484581573\"]//span[text() = '002 | BELO HORIZONTE']");
    By regionalQualidadeExcelenteModoPreparo = By.xpath("//div[@data-zh-id=\"13780856949995230571569\"]//span[text() = '00001 | EXCELENTE']");

    //componetes do 'modo de preparo'
    By campoStatusPadrao = By.xpath("//div[@data-zh-id=\"137808569418106411451442\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoPadrao = By.xpath("//div[@data-zh-id=\"137808569418106411451442\"]//li[text() = 'Ativo']");
    By statusInativoPadrao = By.xpath("//div[@data-zh-id=\"137808569418106411451442\"]//li[text() = 'Inativo']");
    By campoResponsavelPadrao = By.id("NMRPREPPRAT");
    By campoTextoPadrao = By.id("TXPREPPRAT");
    By checarStatusPreparoPadrao = By.xpath("//div[@id=\"grid-137808569415512322241438\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By checarResponsavelPreparoPadrao = By.xpath("//div[@id=\"grid-137808569415512322241438\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By checarTextoPreparoPadrao = By.xpath("//div[@id=\"grid-137808569415512322241438\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    By campoStatusLocal = By.xpath("//div[@data-zh-id=\"137808569412088123211464\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoLocal = By.xpath("//div[@data-zh-id=\"137808569412088123211464\"]//li[text() = 'Ativo']");
    By statusInativoLocal = By.xpath("//div[@data-zh-id=\"137808569412088123211464\"]//li[text() = 'Inativo']");
    By campoResponsavelLocal = By.id("NMRPREPFILI");
    By campoTextoLocal = By.id("TXPREPFILI");
    By checarStatusPreparoLocal = By.xpath("//div[@id=\"grid-137808569422470484101459\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By checarResponsavelPreparoLocal = By.xpath("//div[@id=\"grid-137808569422470484101459\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By checarTextoPreparoLocal = By.xpath("//div[@id=\"grid-137808569422470484101459\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    By campoStatusServico = By.xpath("//div[@data-zh-id=\"13780856949689247711492\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoServico = By.xpath("//div[@data-zh-id=\"13780856949689247711492\"]//li[text() = 'Ativo']");
    By statusInativoServico = By.xpath("//div[@data-zh-id=\"13780856949689247711492\"]//li[text() = 'Inativo']");
    By campoResponsavelServico = By.id("NMRPREPSERV");
    By campoTextoServico = By.id("TXPREPSERV");
    By checarStatusPreparoServico = By.xpath("//div[@id=\"grid-137808569425877529261486\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By checarResponsavelPreparoServico = By.xpath("//div[@id=\"grid-137808569425877529261486\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By checarTextoPreparoServico = By.xpath("//div[@id=\"grid-137808569425877529261486\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    By campoStatusPadraQualidade = By.xpath("//div[@data-zh-id=\"137808569439357168621526\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569439357168621526\"]//li[text() = 'Ativo']");
    By statusInativoPadraoQualidade = By.xpath("//div[@data-zh-id=\"137808569439357168621526\"]//li[text() = 'Inativo']");
    By campoResponsavelPadraoQualidade = By.id("NMPREPPADQ");
    By campoTextoPadraoQualidade = By.id("TXPREPPADQ");
    By checarStatusPreparoPadraoQualidade = By.xpath("//div[@id=\"grid-137808569410689768661520\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By checarResponsavelPreparoPadraoQualidade = By.xpath("//div[@id=\"grid-137808569410689768661520\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By checarTextoPreparoPadraoQualidade = By.xpath("//div[@id=\"grid-137808569410689768661520\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    By campoStatusRegiao = By.xpath("//div[@data-zh-id=\"137808569429952419741553\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By statusAtivoRegiao = By.xpath("//div[@data-zh-id=\"137808569429952419741553\"]//li[text() = 'Ativo']");
    By statusInativoRegiao = By.xpath("//div[@data-zh-id=\"137808569429952419741553\"]//li[text() = 'Inativo']");
    By campoResponsavelRegiao = By.id("NMPREPREGIAO");
    By campoTextoRegiao = By.id("TXPREPREGIAO");
    By checarStatusPreparoRegiao = By.xpath("//div[@id=\"grid-137808569411481650041547\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By checarResponsavelPreparoRegiao = By.xpath("//div[@id=\"grid-137808569411481650041547\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By checarTextoPreparoRegiao = By.xpath("//div[@id=\"grid-137808569411481650041547\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    //componentes do campo de ações
    By acaoConsultarNutrientes = By.xpath("//section[@class=\"popup-content\"]//span[text() = 'Consulta Nutrientes']");
    By consultarColunaCodNutriente = By.xpath("//div[@id=\"grid-137808569410319227971608\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"CDNUTRIENTE\"]/span");
    By consultarColunaNomeNutriente = By.xpath("//div[@id=\"grid-137808569410319227971608\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"NMNUTRIENTE\"]/span");
    By consultarColunaUnidadeNutriente = By.xpath("//div[@id=\"grid-137808569410319227971608\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By consultarColunaQuantNutriente = By.xpath("//div[@id=\"grid-137808569410319227971608\"]//div[@class=\"header-content\"]//div[@data-zh-field-name=\"QTNUTRIENTE\"]/span");

    //componentes que são utilizados em várias funções
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By campoMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemNaoHaRegistro = By.xpath("//div[@class=\"container\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By produtoCarumDadoReceita = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARUM CARVI (FRUTO)']");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoEditar = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li[1]/a");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li[2]/a");
    By botaoAcoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    //componentes da aba embalagem do prato
    By abaEmbalagem = By.xpath("//header[@class=\"zh-header zh-custom-tabbed-widget\"]//div[@class=\"zh-tab-scroller\"]//a[text() ='Embalagens']");
    By campoOpcaoEmbalagem = By.xpath("//div[@data-zh-id=\"13780856944232312739777\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By opcaoPrincipalEmbalagem = By.xpath("//div[@data-zh-id=\"13780856944232312739777\"]//li[text() = 'Principal']");
    By opcaoSecundariaEmbalagem = By.xpath("//div[@data-zh-id=\"13780856944232312739777\"]//li[text() = 'Opção secundária']");
    By campoContainerEmbalagem = By.id("NMCONTAINER");
    By containerAluminio = By.xpath("//div[@data-zh-id=\"13780856944216120547778\"]//span[text() = '00003|ALUMÍNIO']");
    By containerPapelCarbonato = By.xpath("//div[@data-zh-id=\"13780856944216120547778\"]//span[text() = '00006|PAPEL CARBONATO']");
    By campoQuantidadeEmbalagem = By.id("QTPRATCONTAINER");
    By verificarOpcaoEmbalagemAdicionada = By.xpath("//div[@id=\"grid-13780856942673716706774\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By verificarContainerEmbalagemAdicionada = By.xpath("//div[@id=\"grid-13780856942673716706774\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By verificarQuantidadeEmbalagemAdicionada = By.xpath("//div[@id=\"grid-13780856942673716706774\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By mensagemObrigatorioContainerEmbalagem = By.xpath("//div[@data-zh-id=\"13780856944216120547778\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidadeEmbalagem = By.xpath("//div[@data-zh-id=\"13780856941461305139781\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        clearAndSendKeys(campoPesquisar, "Prato");
        click(selecionarOpcaoPrato);
    }

    public void abrirArvoreSelecFeijoadaMagra() {
        tempo();
        click(primeiroCampoArvore);
        tempo();
        click(segundoCampoArvore);
        tempo();
        click(terceiroCampoArovore);
        click(pratoFeijoadaMagra);
    }

    public void adicionarEmbalagem() {
        tempo();
        click(abaEmbalagem);
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoOpcaoEmbalagem, opcaoPrincipalEmbalagem);
        clicarCampoSelecionarValor(campoContainerEmbalagem, containerAluminio);
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encOpcao = getText(verificarOpcaoEmbalagemAdicionada);
        String encContainer = getText(verificarContainerEmbalagemAdicionada);
        String encQuantidade = getText(verificarQuantidadeEmbalagemAdicionada);

        //valores esperados
        String expOpcao = "Principal";
        String expContainer = "ALUMÍNIO";
        String expQuantidade = "5,000";
        Assert.assertEquals(encOpcao, expOpcao, "Verificação da opção após adicionar uma embalagem");
        Assert.assertEquals(encContainer, expContainer, "Verificação do container após adicionar uma embalagem");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação da quantidade após adicionar uma embalagem");

    }

    public void editarEmbalagem() {
        click(abaEmbalagem);
        click(verificarContainerEmbalagemAdicionada);
        click(botaoEditar);
        clicarCampoSelecionarValor(campoOpcaoEmbalagem, opcaoSecundariaEmbalagem);
//        clicarCampoSelecionarValor(campoContainerEmbalagem, containerPapelCarbonato);
        clear(campoQuantidadeEmbalagem);
        sendKeys(campoQuantidadeEmbalagem, "9");
        click(botaoSalvar);

        //valores encontrados
        String encOpcao = getText(verificarOpcaoEmbalagemAdicionada);
//        String encContainer = getText(verificarContainerEmbalagemAdicionada);
        String encQuantidade = getText(verificarQuantidadeEmbalagemAdicionada);

        //valores esperados
        String expOpcao = "Opção secundária";
//        String expContainer = "PAPEL CARBONATO";
        String expQuantidade = "9,000";
        Assert.assertEquals(encOpcao, expOpcao, "Verificação da opção após editar uma embalagem");
//        Assert.assertEquals(encContainer, expContainer, "Verificação do container após editar uma embalagem");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação da quantidade após editar uma embalagem");
    }

    public void excluirEmbalagem() {
        tempo();
        click(verificarContainerEmbalagemAdicionada);
        click(botaoExcluir);
        tempo();

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida na tela após clicar em excluir a embalagem");
        click(botaoSim);

        tempo();
        String mensagemRegistro = getText(mensagemNaoHaRegistro);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagemRegistro, mensagemEsperada, "Verificação da mensagem de não há registro, após excluir a embalagem");
    }

    public void verificarCampoObrigatorioEmbalagem() {
        click(abaEmbalagem);
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagem de campo obrigatório encontrada nos campo de container e quantidade
        String mensagemContainer = getText(mensagemObrigatorioContainerEmbalagem);
        String mensagemQuantidade = getText(mensagemObrigatorioQuantidadeEmbalagem);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagemContainer, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo container da embalagem");
        Assert.assertEquals(mensagemQuantidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo quantidade da embalagem");

    }

    public void adicionarCarumPadrao() {
        Actions actions = new Actions(driver);
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        tempo();
        click(produtoCarum);
        clicarCampoSelecionarValor(campoQuantFixaPadrao, quantFixaSimPadrao);
        sendKeys(campoQuantBrutaPadrao, "1,1");
        clear(campoGanhoCoccaoPadrao);
        sendKeys(campoGanhoCoccaoPadrao, "3");
        clear(campoPerdaLimpezaPadrao);
        sendKeys(campoPerdaLimpezaPadrao, "6");
        tempo();

        actions.doubleClick(driver.findElement(campoDegeloPadrao)).build().perform();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        sendKeys(campoDegeloPadrao, "5");
        clicarCampoSelecionarValor(campoReqParaPadrao, reqParaDistribuicaoPadrao);
        sendKeys(campoComplementoPadrao, "23");
        clicarCampoSelecionarValor(campoCompleEntregaDirPadrao, compleEntregaDiretaSimPadrao);
        click(campoTempoPadrao);
        sendKeys(campoTempoPadrao, "01:30");
        clicarCampoSelecionarValor(campoPrBasePadrao, prBaseSimPadrao);
        sendKeys(campoDiasLimSegPadrao, "15");
        clear(campoApNutricionalPadrao);
        sendKeys(campoApNutricionalPadrao, "98");
        click(botaoSalvar);
    }

    public void verificarCarumPadrao() {
        click(produtoCarum);
        click(botaoEditar);

        //valores encontrados
        String encProduto = getText(campoProduto);
        String encUnidade = getText(campoUnidade);
        String encQuantFixa = getText(campoQuantFixaPadrao);
        String encQuantidade = driver.findElement(campoQuantidadePadrao).getAttribute("value");
        String encQuantBruta = driver.findElement(campoQuantBrutaPadrao).getAttribute("value");
        String encQuantRequerida = driver.findElement(campoQuantRequeridaPadrao).getAttribute("value");
        String encGanhoCoccao = driver.findElement(campoGanhoCoccaoPadrao).getAttribute("value");
        String encApCoccao = driver.findElement(campoApCoccaoPadrao).getAttribute("value");
        String encPerdaLimpeza = driver.findElement(campoPerdaLimpezaPadrao).getAttribute("value");
        String encApLimpeza = driver.findElement(campoApLimpezaPadrao).getAttribute("value");
        String encDegelo = driver.findElement(campoDegeloPadrao).getAttribute("value");
        String encReqPara = getText(campoReqParaPadrao);
        String encComplemento = driver.findElement(campoComplementoPadrao).getAttribute("value");
        String encCompleEntregaDireta = getText(campoCompleEntregaDirPadrao);
        String encTempo = driver.findElement(campoTempoPadrao).getAttribute("value");
        String encPrBase = getText(campoPrBasePadrao);
        String encDiasLimSeg = driver.findElement(campoDiasLimSegPadrao).getAttribute("value");
        String encBaseNutriente = driver.findElement(campoBaseCalcNutrientePadrao).getAttribute("value");
        String encApNutricional = driver.findElement(campoApNutricionalPadrao).getAttribute("value");
        String encQuantCalcNutriente = driver.findElement(campoQuantCalcNutrientePadrao).getAttribute("value");

        //valores esperados
        String expProduto = "CARUM CARVI (FRUTO)";
        String expUnidade = "KG";
        String expQuantFixa = "Sim";
        String expQuantidade = "1,01177";
        String expQuantBruta = "1,10000";
        String expQuantRequerida = "1,04500";
        String expGanhoCoccao = "3,00";
        String expApCoccao = "103,00";
        String expPerdaLimpeza = "6,00";
        String expApLimpeza = "94,00";
        String expDegelo = "5,00";
        String expReqPara = "Distribuição";
        String expComplemento = "23,00000";
        String expCompleEntregaDireta = "Sim";
        String expTempo = "01:30";
        String expPrBase = "Sim";
        String expDiasLimSeg = "15";
        String expBaseNutriente = "0,93318";
        String expApNutricional = "98,00";
        String expQuantCalcNutriente = "0,91453";

        Assert.assertEquals(encProduto, expProduto, "Verificação do valor do campo produto");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do valor do campo unidade");
        Assert.assertEquals(encQuantFixa, expQuantFixa, "Verificação do valor do campo quantidade fixa");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do valor do campo quantidade");
        Assert.assertEquals(encQuantBruta, expQuantBruta, "Verificação do valor do campo quantidade bruta");
        Assert.assertEquals(encQuantRequerida, expQuantRequerida, "Verificação do valor do campo quantidade requerida");
        Assert.assertEquals(encGanhoCoccao, expGanhoCoccao, "Verificação do valor do campo ganho cocção");
        Assert.assertEquals(encApCoccao, expApCoccao, "Verificação do valor do campo ap. cocção");
        Assert.assertEquals(encPerdaLimpeza, expPerdaLimpeza, "Verificação do valor do campo perda limpeza");
        Assert.assertEquals(encApLimpeza, expApLimpeza, "Verificação do valor do campo ap. limpeza");
        Assert.assertEquals(encDegelo, expDegelo, "Verificação do valor do campo degelo");
        Assert.assertEquals(encReqPara, expReqPara, "Verificação do valor do campo requisição para");
        Assert.assertEquals(encComplemento, expComplemento, "Verificação do valor do campo complemento");
        Assert.assertEquals(encCompleEntregaDireta, expCompleEntregaDireta, "Verificação do valor do campo complemento entrega direta");
        Assert.assertEquals(encTempo, expTempo, "Verificação do valor do campo tempo");
        Assert.assertEquals(encPrBase, expPrBase, "Verificação do valor do campo pr. base");
        Assert.assertEquals(encDiasLimSeg, expDiasLimSeg, "Verificação do valor do campo dias limites seguidos");
        Assert.assertEquals(encBaseNutriente, expBaseNutriente, "Verificação do valor do campo base nutriente");
        Assert.assertEquals(encApNutricional, expApNutricional, "Verificação do valor do campo ap. nutricional");
        Assert.assertEquals(encQuantCalcNutriente, expQuantCalcNutriente, "Verificação do valor do campo quant. cálculo nutriente");
        click(botaoCancelar);
    }

    public void adicionarCarumPadraoCamposVazios() {
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagens de campo obrigatório
        String produto = getText(mensagemObrigatorioProdutoPadrao);
        String unidade = getText(mensagemObrigatorioUnidadePadrao);
        String quantidade = getText(mensagemObrigatorioQuantidadePadrao);
        String quantBruta = getText(mensagemObrigatorioQuantBrutaPadrao);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo produto da tela produto receita padrão");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo unidade da tela produto receita padrão");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo quantidade da tela produto receita padrão");
        Assert.assertEquals(quantBruta, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo quantidade bruta da tela produto receita padrão");

        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(botaoCampoProduto), 0, 10).click().build().perform();
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        click(produtoCarum);
        actions.moveToElement(driver.findElement(campoQuantBrutaPadrao), -100, 0).click().build().perform();
        sendKeys(campoQuantBrutaPadrao, "3");
        click(botaoSalvar);
    }

    public void calcularQuantidadePessoaPadrao() {
        tempo();
        click(abaDadosDaReceitaPadrao);
        click(botaoCalcularReceitaPadrao);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Peso calculado do prato é 1.3. Confirma?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular");
        click(botaoSim);
        click(abaProdutosDaReceitaPadrao);
    }

    public void editarDadosReceitaPadrao() {
        click(abaDadosDaReceitaPadrao);
        click(botaoEditar);
        clear(campoNomeFantasiaPadrao);
        sendKeys(campoNomeFantasiaPadrao, "Automação");
        clear(campoQuantidadePessoaPadrao);
        sendKeys(campoQuantidadePessoaPadrao, "7");
        clicarCampoSelecionarValor(campoStatusDadosReceitaPadrao, statusInativoDadosReceitaPadrao);
        click(campoDataInativacaoAutoPadrao);
        sendKeys(campoDataInativacaoAutoPadrao, "05/07/2022");
        clicarCampoSelecionarValor(campoMedidaCaseiraDadosReceitaPadrao, medidaXicaraChaDadosReceitaPadrao);
        clear(campoQuantidadeDadosReceitaPadrao);
        sendKeys(campoQuantidadeDadosReceitaPadrao, "18");
        clear(campoDescricaoPratoDadosReceitaPadrao);
        sendKeys(campoDescricaoPratoDadosReceitaPadrao, "Teste automatizado");
        sendKeys(campoQuantidadeContainerDadosReceitaPadrao, "35");
        clear(campoMinimoContainerPadrao);
        sendKeys(campoMinimoContainerPadrao, "19");
        clear(campoAmostraPadrao);
        sendKeys(campoAmostraPadrao, "4");

        click(botaoSalvar);
        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Só é possível informar uma data para inativação maior que a data atual.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após inserir uma data antes da atual");
        click(botaoOkAlerta);

        clear(campoDataInativacaoAutoPadrao);
        click(campoDataInativacaoAutoPadrao);
        sendKeys(campoDataInativacaoAutoPadrao, "05/07/2031");
        click(botaoSalvar);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após alterar o valor do campo quantidade/pessoa");
        click(botaoSim);
    }

    public void verificarEdicaoDadosReceitaPadrao() {
        tempo();
        click(abaDadosDaReceitaPadrao);
        click(botaoEditar);
        tempo();

        //valores encontrados
        String encNomeFantasia = driver.findElement(campoNomeFantasiaPadrao).getAttribute("value");
        String encQuantidadePessoa = driver.findElement(campoQuantidadePessoaPadrao).getAttribute("value");
        String encStatus = getText(campoStatusDadosReceitaPadrao);
        String encDataInativacao = driver.findElement(campoDataInativacaoAutoPadrao).getAttribute("value");
        String encMedidaCaseira = getText(campoMedidaCaseiraDadosReceitaPadrao);
        String encQuantidade = driver.findElement(campoQuantidadeDadosReceitaPadrao).getAttribute("value");
        String encDescricaoPrato = driver.findElement(campoDescricaoPratoDadosReceitaPadrao).getAttribute("value");
        String encQuantContainer = driver.findElement(campoQuantidadeContainerDadosReceitaPadrao).getAttribute("value");
        String encMinimoContainer = driver.findElement(campoMinimoContainerPadrao).getAttribute("value");
        String encAmostra = driver.findElement(campoAmostraPadrao).getAttribute("value");

        //valores esperados
        String expNomeFantasia = "Automação";
        String expQuantidadePessoa = "7,00000";
        String expStatus = "Inativo";
        String expDataInativacao = "05/07/2031";
        String expMedidaCaseira = "XÍCARA DE CHÁ";
        String expQuantidade = "18,00000";
        String expDescricaoPrato = "Teste automatizado";
        String expQuantContainer = "35,00000";
        String expMinimoContainer = "19,00";
        String expAmostra = "4,00000";

        Assert.assertEquals(encNomeFantasia, expNomeFantasia, "Verificação do campo nome fantasia após a edição dos dados da receita local");
        Assert.assertEquals(encQuantidadePessoa, expQuantidadePessoa, "Verificação do campo quantidade pessoa após a edição dos dados da receita local");
        Assert.assertEquals(encStatus, expStatus, "Verificação do campo status após a edição dos dados da receita local");
        Assert.assertEquals(encDataInativacao, expDataInativacao, "Verificação do campo data inativação após a edição dos dados da receita local");
        Assert.assertEquals(encMedidaCaseira, expMedidaCaseira, "Verificação do campo medida caseira após a edição dos dados da receita local");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do campo quantidade após a edição dos dados da receita local");
        Assert.assertEquals(encDescricaoPrato, expDescricaoPrato, "Verificação do campo descrição prato após a edição dos dados da receita local");
        Assert.assertEquals(encQuantContainer, expQuantContainer, "Verificação do campo quantidade container após a edição dos dados da receita local");
        Assert.assertEquals(encMinimoContainer, expMinimoContainer, "Verificação do campo minímo por container após a edição dos dados da receita local");
        Assert.assertEquals(encAmostra, expAmostra, "Verificação do campo amostra após a edição dos dados da receita local");
        click(botaoCancelar);
        click(abaProdutosDaReceitaPadrao);
    }

    public void desfazerEdicaoDadosReceitaPadrao() {
        click(abaDadosDaReceitaPadrao);
        click(botaoEditar);
        clear(campoNomeFantasiaPadrao);
        clicarCampoSelecionarValor(campoStatusDadosReceitaPadrao, statusAtivoDadosReceitaPadrao);
        click(botaoDataInativacaoPadrao);
        click(botaoMedidaCaseiraDadosReceitaPadrao);
        String quantidadeMedida = driver.findElement(campoQuantidadeDadosReceitaPadrao).getAttribute("value");
        Assert.assertEquals(quantidadeMedida, "", "Verificação do valor do campo da quantidade de medida caseira, após a remoção da medida caseira. A quatidade também deve ser removida");
        clear(campoDescricaoPratoDadosReceitaPadrao);
        clear(campoQuantidadeContainerDadosReceitaPadrao);
        clear(campoMinimoContainerPadrao);
        sendKeys(campoMinimoContainerPadrao, "0");
        clear(campoAmostraPadrao);
        click(botaoSalvar);
        tempo();
        click(abaProdutosDaReceitaPadrao);
    }

    public void editarProdutoCarumPadrao() {
        click(produtoCarumDadoReceita);
        click(botaoEditar);
        clear(campoQuantBrutaPadrao);
        sendKeys(campoQuantBrutaPadrao, "1,3");
        click(botaoSalvar);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deseja realizar alteração proporcional?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após realizar a edição da quantidade do produto CARUM");
        click(botaoSim);
    }

    public void adicionarCarumLocal() {
        Actions actions = new Actions(driver);
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        tempo();
        click(produtoCarum);
        clicarCampoSelecionarValor(campoQuantFixaLocal, quantiFixSimLocal);
        sendKeys(campoQuantBrutaLocal, "0,7");
        clear(campoGanhoCoccaoLocal);
        sendKeys(campoGanhoCoccaoLocal, "-40");
        clear(campoPerdaLimpezaLocal);
        sendKeys(campoPerdaLimpezaLocal, "8");

        tempo();
        actions.doubleClick(driver.findElement(campoDegeloLocal)).build().perform();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        sendKeys(campoDegeloLocal, "5");
        clicarCampoSelecionarValor(campoReqParaLocal, reqParaDistribuicaoLocal);
        sendKeys(campoComplementoLocal, "15");
        clicarCampoSelecionarValor(campoCompleEntregaDirLocal, compleEntrefaDirSimLocal);
        click(campoTempoLocal);
        sendKeys(campoTempoLocal, "00:45");
        clicarCampoSelecionarValor(campoPrBaseLocal, prBaseSimLocal);
        sendKeys(campoDiaLimSegLocal, "15");
        clear(campoApNutricionalLocal);
        sendKeys(campoApNutricionalLocal, "98");
        click(botaoSalvar);
    }

    public void verificarCarumLocal() {
        click(produtoCarum);
        click(botaoEditar);

        //valores encontrados
        String encProduto = getText(campoProduto);
        String encUnidade = getText(campoUnidade);
        String encQuantFixa = getText(campoQuantFixaLocal);
        String encQuantidade = driver.findElement(campoQuantidadeLocal).getAttribute("value");
        String encQuantBruta = driver.findElement(campoQuantBrutaLocal).getAttribute("value");
        String encQuantRequerida = driver.findElement(campoQuantRequeridaLocal).getAttribute("value");
        String encGanhoCoccao = driver.findElement(campoGanhoCoccaoLocal).getAttribute("value");
        String encApCoccao = driver.findElement(campoApCoccaoLocal).getAttribute("value");
        String encPerdaLimpeza = driver.findElement(campoPerdaLimpezaLocal).getAttribute("value");
        String encApLimpeza = driver.findElement(campoApLimpezaLocal).getAttribute("value");
        String encDegelo = driver.findElement(campoDegeloLocal).getAttribute("value");
        String encReqPara = getText(campoReqParaLocal);
        String encComplemento = driver.findElement(campoComplementoLocal).getAttribute("value");
        String encCompleEntregaDireta = getText(campoCompleEntregaDirLocal);
        String encTempo = driver.findElement(campoTempoLocal).getAttribute("value");
        String encPrBase = getText(campoPrBaseLocal);
        String encDiasLimSeg = driver.findElement(campoDiaLimSegLocal).getAttribute("value");
        String encBaseNutriente = driver.findElement(campoBaseCalcNutrienteLocal).getAttribute("value");
        String encApNutricional = driver.findElement(campoApNutricionalLocal).getAttribute("value");
        String encQuantCalcNutriente = driver.findElement(campoQuantCalcNutrienteLocal).getAttribute("value");

        //valores esperados
        String expProduto = "CARUM CARVI (FRUTO)";
        String expUnidade = "KG";
        String expQuantFixa = "Sim";
        String expQuantidade = "0,36708";
        String expQuantBruta = "0,70000";
        String expQuantRequerida = "0,66500";
        String expGanhoCoccao = "-40,00";
        String expApCoccao = "60,00";
        String expPerdaLimpeza = "8,00";
        String expApLimpeza = "92,00";
        String expDegelo = "5,00";
        String expReqPara = "Distribuição";
        String expComplemento = "15,00000";
        String expCompleEntregaDireta = "Sim";
        String expTempo = "00:45";
        String expPrBase = "Sim";
        String expDiasLimSeg = "15";
        String expBaseNutriente = "0,58121";
        String expApNutricional = "98,00";
        String expQuantCalcNutriente = "0,56959";

        Assert.assertEquals(encProduto, expProduto, "Verificação do valor do campo produto");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do valor do campo unidade");
        Assert.assertEquals(encQuantFixa, expQuantFixa, "Verificação do valor do campo quantidade fixa");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do valor do campo quantidade");
        Assert.assertEquals(encQuantBruta, expQuantBruta, "Verificação do valor do campo quantidade bruta");
        Assert.assertEquals(encQuantRequerida, expQuantRequerida, "Verificação do valor do campo quantidade requerida");
        Assert.assertEquals(encGanhoCoccao, expGanhoCoccao, "Verificação do valor do campo ganho cocção");
        Assert.assertEquals(encApCoccao, expApCoccao, "Verificação do valor do campo ap. cocção");
        Assert.assertEquals(encPerdaLimpeza, expPerdaLimpeza, "Verificação do valor do campo perda limpeza");
        Assert.assertEquals(encApLimpeza, expApLimpeza, "Verificação do valor do campo ap. limpeza");
        Assert.assertEquals(encDegelo, expDegelo, "Verificação do valor do campo degelo");
        Assert.assertEquals(encReqPara, expReqPara, "Verificação do valor do campo requisição para");
        Assert.assertEquals(encComplemento, expComplemento, "Verificação do valor do campo complemento");
        Assert.assertEquals(encCompleEntregaDireta, expCompleEntregaDireta, "Verificação do valor do campo complemento entrega direta");
        Assert.assertEquals(encTempo, expTempo, "Verificação do valor do campo tempo");
        Assert.assertEquals(encPrBase, expPrBase, "Verificação do valor do campo pr. base");
        Assert.assertEquals(encDiasLimSeg, expDiasLimSeg, "Verificação do valor do campo dias limites seguidos");
        Assert.assertEquals(encBaseNutriente, expBaseNutriente, "Verificação do valor do campo base nutriente");
        Assert.assertEquals(encApNutricional, expApNutricional, "Verificação do valor do campo ap. nutricional");
        Assert.assertEquals(encQuantCalcNutriente, expQuantCalcNutriente, "Verificação do valor do campo quant. cálculo nutriente");
        click(botaoCancelar);
    }

    public void adicionarCarumLocalCamposVazios() {
        tempo();
        tempo();
        click(botaoAdicionar);
        tempo();
        tempo();
        click(botaoSalvar);

        //mensagens de campo obrigatório
        String produto = getText(mensagemObrigatorioProdutoLocal);
        String unidade = getText(mensagemObrigatorioUnidadeLocal);
        String quantidade = getText(mensagemObrigatorioQuantidadeLocal);
        String quantBruta = getText(mensagemObrigatorioQuantBrutaLocal);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo produto da tela produto receita local");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo unidade da tela produto receita local");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo quantidade da tela produto receita local");
        Assert.assertEquals(quantBruta, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo quantidade bruta da tela produto receita local");

        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(botaoCampoProduto), 0, 10).click().build().perform();
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        click(produtoCarum);
        actions.moveToElement(driver.findElement(campoQuantBrutaLocal), -100, 0).click().build().perform();
        sendKeys(campoQuantBrutaLocal, "3");
        click(botaoSalvar);
    }

    public void calcularQuantidadePessoaLocal() {
        tempo();
        click(abaDadosDaReceitaLocal);
        click(botaoCalcularReceitaLocal);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Peso calculado do prato é 1.25. Confirma?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular");
        click(botaoSim);
        tempo();
        click(abaProdutosDaReceitaLocal);
    }

    public void editarDadosReceitaLocal() {
        click(abaDadosDaReceitaLocal);
        click(botaoEditar);
        clear(campoNomeFantasiaLocal);
        sendKeys(campoNomeFantasiaLocal, "Automação");
        clear(campoQuantidadePessoaLocal);
        sendKeys(campoQuantidadePessoaLocal, "5");
        clicarCampoSelecionarValor(campoStatusDadosReceitaLocal, statusInativoDadosReceitaLocal);
        click(campoDataInativacaoAutoLocal);
        sendKeys(campoDataInativacaoAutoLocal, "05/07/2022");
        clicarCampoSelecionarValor(campoMedidaCaseiraDadosReceitaLocal, medidaXicaraChaDadosReceitaLocal);
        sendKeys(campoQuantidadeDadosReceitaLocal, "15");
        clear(campoDescricaoPratoDadosReceitaLocal);
        sendKeys(campoDescricaoPratoDadosReceitaLocal, "Teste automatizado");
        sendKeys(campoQuantidadeContainerDadosReceitaLocal, "40");
        clear(campoMinimoContainerLocal);
        sendKeys(campoMinimoContainerLocal, "12");
        clear(campoAmostraLocal);
        sendKeys(campoAmostraLocal, "3");

        click(botaoSalvar);
        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Só é possível informar uma data para inativação maior que a data atual.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após inserir uma data antes da atual");
        click(botaoOkAlerta);

        clear(campoDataInativacaoAutoLocal);
        click(campoDataInativacaoAutoLocal);
        sendKeys(campoDataInativacaoAutoLocal, "05/07/2031");
        click(botaoSalvar);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após alterar o valor do campo quantidade/pessoa");
        click(botaoSim);
    }

    public void verificarEdicaoDadosReceitaLocal() {
        click(abaDadosDaReceitaLocal);
        click(botaoEditar);

        //valores encontrados
        String encNomeFantasia = driver.findElement(campoNomeFantasiaLocal).getAttribute("value");
        String encQuantidadePessoa = driver.findElement(campoQuantidadePessoaLocal).getAttribute("value");
        String encStatus = getText(campoStatusDadosReceitaLocal);
        String encDataInativacao = driver.findElement(campoDataInativacaoAutoLocal).getAttribute("value");
        String encMedidaCaseira = getText(campoMedidaCaseiraDadosReceitaLocal);
        String encQuantidade = driver.findElement(campoQuantidadeDadosReceitaLocal).getAttribute("value");
        String encDescricaoPrato = driver.findElement(campoDescricaoPratoDadosReceitaLocal).getAttribute("value");
        String encQuantContainer = driver.findElement(campoQuantidadeContainerDadosReceitaLocal).getAttribute("value");
        String encMinimoContainer = driver.findElement(campoMinimoContainerLocal).getAttribute("value");
        String encAmostra = driver.findElement(campoAmostraLocal).getAttribute("value");

        //valores esperados
        String expNomeFantasia = "Automação";
        String expQuantidadePessoa = "5,00000";
        String expStatus = "Inativo";
        String expDataInativacao = "05/07/2031";
        String expMedidaCaseira = "XÍCARA DE CHÁ";
        String expQuantidade = "15,00000";
        String expDescricaoPrato = "Teste automatizado";
        String expQuantContainer = "40,00000";
        String expMinimoContainer = "12,00";
        String expAmostra = "3,00000";

        Assert.assertEquals(encNomeFantasia, expNomeFantasia, "Verificação do campo nome fantasia após a edição dos dados da receita local");
        Assert.assertEquals(encQuantidadePessoa, expQuantidadePessoa, "Verificação do campo quantidade pessoa após a edição dos dados da receita local");
        Assert.assertEquals(encStatus, expStatus, "Verificação do campo status após a edição dos dados da receita local");
        Assert.assertEquals(encDataInativacao, expDataInativacao, "Verificação do campo data inativação após a edição dos dados da receita local");
        Assert.assertEquals(encMedidaCaseira, expMedidaCaseira, "Verificação do campo medida caseira após a edição dos dados da receita local");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do campo quantidade após a edição dos dados da receita local");
        Assert.assertEquals(encDescricaoPrato, expDescricaoPrato, "Verificação do campo descrição prato após a edição dos dados da receita local");
        Assert.assertEquals(encQuantContainer, expQuantContainer, "Verificação do campo quantidade container após a edição dos dados da receita local");
        Assert.assertEquals(encMinimoContainer, expMinimoContainer, "Verificação do campo minímo por container após a edição dos dados da receita local");
        Assert.assertEquals(encAmostra, expAmostra, "Verificação do campo amostra após a edição dos dados da receita local");
        click(botaoCancelar);
        click(abaProdutosDaReceitaLocal);
    }

    public void desfazerEdicaoDadosReceitaLocal() {
        click(abaDadosDaReceitaLocal);
        click(botaoEditar);
        clear(campoNomeFantasiaLocal);
        clicarCampoSelecionarValor(campoStatusDadosReceitaLocal, statusAtivoDadosReceitaLocal);
        click(botaoDataInativacaoLocal);
        click(botaoMedidaCaseiraDadosReceitaLocal);
        String quantidadeMedida = driver.findElement(campoQuantidadeDadosReceitaLocal).getAttribute("value");
        Assert.assertEquals(quantidadeMedida, "", "Verificação do valor do campo da quantidade de medida caseira, após a remoção da medida caseira. A quatidade também deve ser removida");
        clear(campoDescricaoPratoDadosReceitaLocal);
        clear(campoQuantidadeContainerDadosReceitaLocal);
        clear(campoMinimoContainerLocal);
        sendKeys(campoMinimoContainerLocal, "0");
        clear(campoAmostraLocal);
        click(botaoSalvar);
        tempo();
        click(abaProdutosDaReceitaLocal);
    }

    public void editarProdutoCarumLocal() {
        click(produtoCarumDadoReceita);
        click(botaoEditar);
        clear(campoQuantBrutaLocal);
        sendKeys(campoQuantBrutaLocal, "1,25");
        click(botaoSalvar);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deseja realizar alteração proporcional?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após realizar a edição da quantidade do produto CARUM");
        click(botaoSim);
    }

    public void adicionarCarumServico() {
        Actions actions = new Actions(driver);
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        click(produtoCarum);
        tempo();
        clicarCampoSelecionarValor(campoQuantFixaServico, quantFixaSimServico);
        sendKeys(campoQuantBrutaServico, "2,3");
        clear(campoGanhoCoccaoServico);
        sendKeys(campoGanhoCoccaoServico, "4");
        clear(campoPerdaLimpezaServico);
        sendKeys(campoPerdaLimpezaServico, "5");
        tempo();
        actions.doubleClick(driver.findElement(campoDegeloServico)).build().perform();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        sendKeys(campoDegeloServico, "3");
        clicarCampoSelecionarValor(campoReqParaServico, reqParaDistribuicaoServico);
        clear(campoComplementoServico);
        sendKeys(campoComplementoServico, "2");
        clicarCampoSelecionarValor(campoCompleEntregaDiretaServico, compleEntregaDiretaSimServico);
        click(campoTempoServico);
        sendKeys(campoTempoServico, "03:00");
        clicarCampoSelecionarValor(campoPrBaseServico, prBaseSimServico);
        clear(campoDiaLimSegServico);
        sendKeys(campoDiaLimSegServico, "6");
        clear(campoApNutricionalServico);
        sendKeys(campoApNutricionalServico, "98");
        click(botaoSalvar);
    }

    public void verificarCarumServico() {
        click(produtoCarumDadoReceita);
        click(botaoEditar);

        //valores encontrados
        String encProduto = getText(campoProduto);
        String encUnidade = getText(campoUnidade);
        String encQuantFixa = getText(campoQuantFixaServico);
        String encQuantidade = driver.findElement(campoQuantidadeServico).getAttribute("value");
        String encQuantBruta = driver.findElement(campoQuantBrutaServico).getAttribute("value");
        String encQuantRequerida = driver.findElement(campoQuantRequeridaServico).getAttribute("value");
        String encGanhoCoccao = driver.findElement(campoGanhoCoccaoServico).getAttribute("value");
        String encApCoccao = driver.findElement(campoApCoccaoServico).getAttribute("value");
        String encPerdaLimpeza = driver.findElement(campoPerdaLimpezaServico).getAttribute("value");
        String encApLimpeza = driver.findElement(campoApLimpezaServico).getAttribute("value");
        String encDegelo = driver.findElement(campoDegeloServico).getAttribute("value");
        String encReqPara = getText(campoReqParaServico);
        String encComplemento = driver.findElement(campoComplementoServico).getAttribute("value");
        String encCompleEntregaDireta = getText(campoCompleEntregaDiretaServico);
        String encTempo = driver.findElement(campoTempoServico).getAttribute("value");
        String encPrBase = getText(campoPrBaseServico);
        String encDiaLimSeg = driver.findElement(campoDiaLimSegServico).getAttribute("value");
        String encBaseCalcNutriente = driver.findElement(campoBaseCalcNutrienteServico).getAttribute("value");
        String encApNutricional = driver.findElement(campoApNutricionalServico).getAttribute("value");
        String encQuantCalcNutriente = driver.findElement(quantCalculoNutrienteServico).getAttribute("value");

        //valores esperados
        String expProduto = "CARUM CARVI (FRUTO)";
        String expUnidade = "KG";
        String expQauntFixa = "Sim";
        String expQuantidade = "2,20423";
        String expQuantBruta = "2,30000";
        String expQuantRequerida = "2,23100";
        String expGanhoCoccao = "4,00";
        String expApCoccao = "104,00";
        String expPerdaLimpeza = "5,00";
        String expApLimpeza = "95,00";
        String expDegelo = "3,00";
        String expReqPara = "Distribuição";
        String expComplemento = "2,00000";
        String expCompleEntregaDireta = "Sim";
        String expTempo = "03:00";
        String expPrBase = "Sim";
        String expDiaSemLim = "6";
        String expBaseCalcNutriente = "2,05587";
        String expApNutricional = "98,00";
        String expQuantCalcNutriente = "2,01475";

        Assert.assertEquals(encProduto, expProduto, "Verificação do campo produto, no produto da receita serviço");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do campo unidade, no produto da receita serviço");
        Assert.assertEquals(encQuantFixa, expQauntFixa, "Verificação do campo quantidade fixa, no produto da receita serviço");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do campo quantidade, no produto da receita serviço");
        Assert.assertEquals(encQuantBruta, expQuantBruta, "Verificação do campo quantidade bruta, no produto da receita serviço");
        Assert.assertEquals(encQuantRequerida, expQuantRequerida, "Verificação do campo quantidade requerida, no produto da receita serviço");
        Assert.assertEquals(encGanhoCoccao, expGanhoCoccao, "Verificação do campo ganho cocção, no produto da receita serviço");
        Assert.assertEquals(encApCoccao, expApCoccao, "Verificação do campo ap. cocção, no produto da receita serviço");
        Assert.assertEquals(encPerdaLimpeza, expPerdaLimpeza, "Verificação do campo perda limpeza, no produto da receita serviço");
        Assert.assertEquals(encApLimpeza, expApLimpeza, "Verificação do campo ap. limpeza, no produto da receita serviço");
        Assert.assertEquals(encDegelo, expDegelo, "Verificação do campo degelo, no produto no da receita serviço");
        Assert.assertEquals(encReqPara, expReqPara, "Verificação do campo req. para, no produto no da receita serviço");
        Assert.assertEquals(encComplemento, expComplemento, "Verificação do campo complemento, no produto da receita serviço");
        Assert.assertEquals(encCompleEntregaDireta, expCompleEntregaDireta, "Verificação do campo complemento entrega direta, no produto da receita serviço");
        Assert.assertEquals(encTempo, expTempo, "Verificação do campo tempo, no produto no da receita serviço");
        Assert.assertEquals(encPrBase, expPrBase, "Verificação do campo pr. base, no produto da receita serviço");
        Assert.assertEquals(encDiaLimSeg, expDiaSemLim, "Verificação do campo dias sem limite, no produto da receita serviço");
        Assert.assertEquals(encBaseCalcNutriente, expBaseCalcNutriente, "Verificação do campo base calc. nutriente, no produto da receita serviço");
        Assert.assertEquals(encApNutricional, expApNutricional, "Verificação do campo ap. nutricional, no produto da receita serviço");
        Assert.assertEquals(encQuantCalcNutriente, expQuantCalcNutriente, "Verificação do campo qt. cálculo nutriente, no produto da receita serviço");
        click(botaoCancelar);
    }

    public void adicionarCarumServicoCamposVazios() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagens de campo obrigatório
        String produto = getText(mensagemObrigatorioProdutoServico);
        String unidade = getText(mensagemObrigatorioUnidadeServico);
        String quantidade = getText(mensagemObrigatorioQuantidadeServico);
        String quantBruta = getText(mensagemObrigatorioQuantBrutaServico);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo produto");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo unidade");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo quantidade");
        Assert.assertEquals(quantBruta, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo quantidade bruta");

        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(botaoCampoProduto), 0, 10).click().build().perform();
        tempo();
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        click(produtoCarum);
        actions.moveToElement(driver.findElement(campoQuantBrutaServico), -100, 0).click().build().perform();
        sendKeys(campoQuantBrutaServico, "4,2");
        click(botaoSalvar);
    }

    public void editarProdutoCarumServico() {
        click(produtoCarumDadoReceita);
        click(botaoEditar);
        clear(campoQuantBrutaServico);
        sendKeys(campoQuantBrutaServico, "2,3");
        click(botaoSalvar);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deseja realizar alteração proporcional?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após realizar a edição da quantidade do produto CARUM");
        click(botaoSim);
    }

    public void calcularQuantidadePessoaServico() {
        tempo();
        click(abaDadosDaReceitaServico);
        click(botaoCalcularReceitaServico);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Peso calculado do prato é 2.3. Confirma?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular");
        click(botaoSim);
        click(abaProdutosDaReceitaServico);
    }

    public void editarDadosReceitaServico() {;
        click(abaDadosDaReceitaServico);
        click(botaoEditar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "ARNICA MONTANA 6CH");
        click(produtoProducaoArnica);
        tempo();
        clear(campoNomeFantasiaServico);
        sendKeys(campoNomeFantasiaServico, "Automação");
        clear(campoQuantidadePessoaServico);
        sendKeys(campoQuantidadePessoaServico, "5");
        clicarCampoSelecionarValor(campoStatusDadosReceitaServico, statusInativoDadosReceitaServico);
        click(campoDataInativacaoAutoServico);
        sendKeys(campoDataInativacaoAutoServico, "05/07/2022");
        clicarCampoSelecionarValor(campoMedidaCaseiraDadosReceitaServico, medidaXicaraChaDadosReceitaServico);
        sendKeys(campoQuantidadeDadosReceitaServico, "15");
        clear(campoDescricaoPratoDadosReceitaServico);
        sendKeys(campoDescricaoPratoDadosReceitaServico, "Teste automatizado");
        clear(campoQuantidadeContainerDadosReceitaServico);
        sendKeys(campoQuantidadeContainerDadosReceitaServico, "40");
        clear(campoMinimoContainerServico);
        sendKeys(campoMinimoContainerServico, "12");
        clear(campoAmostraServico);
        sendKeys(campoAmostraServico, "3");

        click(botaoSalvar);
        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Só é possível informar uma data para inativação maior que a data atual.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após inserir uma data antes da atual");
        click(botaoOkAlerta);

        clear(campoDataInativacaoAutoServico);
        click(campoDataInativacaoAutoServico);
        sendKeys(campoDataInativacaoAutoServico, "05/07/2031");
        click(botaoSalvar);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após alterar o valor do campo quantidade/pessoa");
        click(botaoSim);
    }

    public void verificarEdicaoDadosReceitaServico() {
        click(abaDadosDaReceitaServico);
        click(botaoEditar);

        //valores encontrados
        String encProdutoProducao = getText(campoProduto);
        String encNomeFantasia = driver.findElement(campoNomeFantasiaServico).getAttribute("value");
        String encQuantidadePessoa = driver.findElement(campoQuantidadePessoaServico).getAttribute("value");
        String encStatus = getText(campoStatusDadosReceitaServico);
        String encDataInativacao = driver.findElement(campoDataInativacaoAutoServico).getAttribute("value");
        String encMedidaCaseira = getText(campoMedidaCaseiraDadosReceitaServico);
        String encQuantidade = driver.findElement(campoQuantidadeDadosReceitaServico).getAttribute("value");
        String encDescricaoPrato = driver.findElement(campoDescricaoPratoDadosReceitaServico).getAttribute("value");
        String encQuantContainer = driver.findElement(campoQuantidadeContainerDadosReceitaServico).getAttribute("value");
        String encMinimoContainer = driver.findElement(campoMinimoContainerServico).getAttribute("value");
        String encAmostra = driver.findElement(campoAmostraServico).getAttribute("value");

        //valores esperados
        String expProdutoProducao = "1.01.4.2.01.078.00 | ARNICA MONTANA 6CH";
        String expNomeFantasia = "Automação";
        String expQuantidadePessoa = "5,00000";
        String expStatus = "Inativo";
        String expDataInativacao = "05/07/2031";
        String expMedidaCaseira = "XÍCARA DE CHÁ";
        String expQuantidade = "15,00000";
        String expDescricaoPrato = "Teste automatizado";
        String expQuantContainer = "40,00000";
        String expMinimoContainer = "12,00";
        String expAmostra = "3,00000";

        Assert.assertEquals(encProdutoProducao, expProdutoProducao, "Verificação do campo produto produção após a edição dos dados da receita local");
        Assert.assertEquals(encNomeFantasia, expNomeFantasia, "Verificação do campo nome fantasia após a edição dos dados da receita local");
        Assert.assertEquals(encQuantidadePessoa, expQuantidadePessoa, "Verificação do campo quantidade pessoa após a edição dos dados da receita local");
        Assert.assertEquals(encStatus, expStatus, "Verificação do campo status após a edição dos dados da receita local");
        Assert.assertEquals(encDataInativacao, expDataInativacao, "Verificação do campo data inativação após a edição dos dados da receita local");
        Assert.assertEquals(encMedidaCaseira, expMedidaCaseira, "Verificação do campo medida caseira após a edição dos dados da receita local");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do campo quantidade após a edição dos dados da receita local");
        Assert.assertEquals(encDescricaoPrato, expDescricaoPrato, "Verificação do campo descrição prato após a edição dos dados da receita local");
        Assert.assertEquals(encQuantContainer, expQuantContainer, "Verificação do campo quantidade container após a edição dos dados da receita local");
        Assert.assertEquals(encMinimoContainer, expMinimoContainer, "Verificação do campo minímo por container após a edição dos dados da receita local");
        Assert.assertEquals(encAmostra, expAmostra, "Verificação do campo amostra após a edição dos dados da receita local");
        click(botaoCancelar);
        click(abaProdutosDaReceitaServico);
    }

    public void desfazerEdicaoDadosReceitaServico() {
        click(abaDadosDaReceitaServico);
        click(botaoEditar);
        click(botaoCampoProduto);
        clear(campoNomeFantasiaServico);
        clear(campoQuantidadePessoaServico);
        clicarCampoSelecionarValor(campoStatusDadosReceitaServico, statusAtivoDadosReceitaServico);
        click(botaoDataInativacaoServico);
        click(botaoMedidaCaseiraDadosReceitaServico);
        String quantidadeMedida = driver.findElement(campoQuantidadeDadosReceitaServico).getAttribute("value");
        Assert.assertEquals(quantidadeMedida, "", "Verificação do valor do campo da quantidade de medida caseira, após a remoção da medida caseira. A quatidade também deve ser removida");
        clear(campoDescricaoPratoDadosReceitaServico);
        clear(campoQuantidadeContainerDadosReceitaServico);
        clear(campoMinimoContainerServico);
        sendKeys(campoMinimoContainerServico, "0");
        clear(campoAmostraServico);
        click(botaoSalvar);
        tempo();
        click(abaProdutosDaReceitaServico);
    }

    public void adicionarCarumPadraoQualidade() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        tempo();
        click(produtoCarum);
        clicarCampoSelecionarValor(campoQuantFixaPadraQualidade, quantFixaSimPadraoQualidade);
        clicarCampoSelecionarValor(campoPrBasePadraoQualidade, prBaseSimPadraoQualidade);
        sendKeys(campoQuantBrutaPadraoQualidade, "3,3");
        click(botaoSalvar);
    }

    public void verificarCarumPadraoQualidade() {
        tempo();
        click(produtoCarum);
        tempo();
        click(botaoEditar);

        //valores encontrados
        String encProduto = getText(campoProduto);
        String encUnidade = getText(campoUnidade);
        String encQuantFix = getText(campoQuantFixaPadraQualidade);
        String encPrBase = getText(campoPrBasePadraoQualidade);
        String encQuantBruta = driver.findElement(campoQuantBrutaPadraoQualidade).getAttribute("value");
        String encGanhoCoccao = driver.findElement(campoGanhoCoccaoPadraoQualidade).getAttribute("value");
        String encApCoccao = driver.findElement(campoApCoccaoPadraoQualidade).getAttribute("value");
        String encPerdaLimpeza = driver.findElement(campoPerdaLimpezaPadraoQualidade).getAttribute("value");
        String encApLimpeza = driver.findElement(campoApLimpezaPadraoQualidade).getAttribute("value");

        //valores esperados
        String expProduto = "CARUM CARVI (FRUTO)";
        String expUnidade = "KG";
        String expQuantFix = "Sim";
        String expPrBase = "Sim";
        String expQuantBruta = "3,30000";
        String expGanhoCoccao = "0,00";
        String expApCoccao = "100,00";
        String expPerdaLimpeza = "0,00";
        String expApLimpeza = "100,00";

        Assert.assertEquals(encProduto, expProduto, "Verificação do valor do campo produto, da receita padrão de qualidade");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do valor do campo unidade, da receita padrão de qualidade");
        Assert.assertEquals(encQuantFix, expQuantFix, "Verificação do valor de quantidade fixa, da receita padrão de qualidade");
        Assert.assertEquals(encPrBase, expPrBase, "Verificação do valor de pr base, da receita padrão de qualidade");
        Assert.assertEquals(encQuantBruta, expQuantBruta, "Verificação do valor de quantidade bruta, da receita padrão de qualidade");
        Assert.assertEquals(encGanhoCoccao, expGanhoCoccao, "Verificação do valor ganho cocção, da receita padrão de qualidade");
        Assert.assertEquals(encApCoccao, expApCoccao, "Verificação do valor de ap. cocção, da receita padrão de qualidade");
        Assert.assertEquals(encPerdaLimpeza, expPerdaLimpeza, "Verificação do valor da perda limpeza, da receita padrão de qualidade");
        Assert.assertEquals(encApLimpeza, expApLimpeza, "Verificação do valor do ap. limpeza, da receita padrão de qualidade");
        click(botaoCancelar);
    }

    public void editarProdutoCarumPadraoQualidade() {
        tempo();
        click(produtoCarumDadoReceita);
        click(botaoEditar);
        clear(campoQuantBrutaPadraoQualidade);
        sendKeys(campoQuantBrutaPadraoQualidade, "2,8");
        click(botaoSalvar);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deseja realizar alteração proporcional?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após realizar a edição da quantidade do produto CARUM");
        click(botaoSim);
    }

    public void adicionarCarumPadraoQualidadeCamposVazios() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagens de campo obrigatório
        String produto = getText(mensagemObrigatorioProdutoPadraoQualidade);
        String unidade = getText(mensagemObrigatorioUnidadePadraoQualidade);
        String quantidade = getText(mensagemObrigatorioQuantidadePadraoQualidade);
        String quantBruta = getText(mensagemObrigatorioQuantBrutaPadraoQualidade);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo produto da receita padrão de qualidade");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo unidade da receita padrão de qualidade");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo quantidade da receita padrão de qualidade");
        Assert.assertEquals(quantBruta, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo quantidade bruta da receita padrão de qualidade");

        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(botaoCampoProduto), 0, 10).click().build().perform();
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        click(produtoCarum);
        actions.moveToElement(driver.findElement(campoQuantBrutaPadraoQualidade), -100, 0).click().build().perform();
        sendKeys(campoQuantBrutaPadraoQualidade, "3");
        click(botaoSalvar);
    }

    public void editarDadosReceitaPadraoQualidade() {
        click(abaDadosDaReceitaPadraoQualidade);
        click(botaoEditar);
        clear(campoQuantidadePessoaPadraoQualidade);
        sendKeys(campoQuantidadePessoaPadraoQualidade, "1,5");
        click(campoDataInativacaoAutoPadraoQualidade);
        sendKeys(campoDataInativacaoAutoPadraoQualidade, "05/07/2022");
        click(botaoSalvar);
        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Só é possível informar uma data para inativação maior que a data atual.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após inserir uma data antes da atual");
        click(botaoOkAlerta);

        clear(campoDataInativacaoAutoServico);
        click(campoDataInativacaoAutoServico);
        sendKeys(campoDataInativacaoAutoServico, "05/07/2031");
        click(botaoSalvar);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após alterar o valor do campo quantidade/pessoa");
        click(botaoSim);
    }

    public void verificarEdicaoDadosReceitaPadraoQualidade() {
        click(abaDadosDaReceitaPadraoQualidade);
        click(botaoEditar);

        //valores encontrados
        String encQuantidadePessoa = driver.findElement(campoQuantidadePessoaPadraoQualidade).getAttribute("value");
        String encDataInativacaoAuto = driver.findElement(campoDataInativacaoAutoPadraoQualidade).getAttribute("value");

        //valores esperados
        String expQuantidadePessoa = "1,50000";
        String expDataInativacaoAuto = "05/07/2031";
        Assert.assertEquals(encQuantidadePessoa, expQuantidadePessoa, "Verificação do campo quantidade por pessoa após a edição dos dados da receita padrão de qualidade");
        Assert.assertEquals(encDataInativacaoAuto, expDataInativacaoAuto, "Verificação do campo data inativação automática após a edição dos dados da receita padrão de qualidade");
        tempo();
        click(botaoCancelar);
        click(abaProdutosDaReceitaPadraoQualidade);
    }

    public void desfazerEdicaoDadosReceitaPadraoQualidade() {
        click(abaDadosDaReceitaPadraoQualidade);
        click(botaoEditar);
        clear(campoQuantidadePessoaPadraoQualidade);
        click(botaoDataInativacaoPadraoQualidade);
        click(botaoSalvar);
        click(abaProdutosDaReceitaPadraoQualidade);
    }

    public void calcularQuantidadePessoaPadraoQualidade() {
        tempo();
        click(abaDadosDaReceitaPadraoQualidade);
        click(botaoCalcularReceitaPadraoQualidade);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Peso calculado do prato é 2.8. Confirma?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular");
        click(botaoSim);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular e confirmar o peso calculado");
        click(botaoSim);
        click(abaProdutosDaReceitaPadraoQualidade);
    }

    public void adicionarCarumRegiao() {
        click(botaoAdicionar);
        tempo();
        click(botaoCampoProduto);
        tempo();
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        tempo();
        click(produtoCarum);
        clicarCampoSelecionarValor(campoQuantFixaRegiao, quantFixaSimRegiao);
        clicarCampoSelecionarValor(campoPrbaseRegiao, prBaseSimRegiao);
        sendKeys(campoQuantBrutaRegiao, "2,5");
        click(botaoSalvar);
    }

    public void verificarCarumRegiao() {
        click(produtoCarum);
        click(botaoEditar);

        //valores encontrados
        String encQuantFixa = getText(campoQuantFixaRegiao);
        String encPrBase = getText(campoPrbaseRegiao);
        String encQuantidade = driver.findElement(campoQuantidadeRegiao).getAttribute("value");
        String encQuantBruta = driver.findElement(campoQuantBrutaRegiao).getAttribute("value");
        String encGanhoCoccao = driver.findElement(campoGanhoCoccaoRegiao).getAttribute("value");
        String encApCoccao = driver.findElement(campoApCoccaoRegiao).getAttribute("value");
        String encPerdaLimpeza = driver.findElement(campoPerdaLimpezaRegiao).getAttribute("value");
        String encApLimpeza = driver.findElement(campoApLimpezaCoccaoRegiao).getAttribute("value");

        //valores esperados
        String expQuantFixa = "Sim";
        String expPrBase = "Sim";
        String expQuantidade = "2,50000";
        String expQuantBruta = "2,50000";
        String expGanhoCoccao = "0,00";
        String expApCoccao = "100,00";
        String expPerdaLimpeza = "0,00";
        String expApLimpeza = "100,00";

        Assert.assertEquals(encQuantFixa, expQuantFixa, "Verificação do campo quantidade fixa, após adicionar o carum na receita região");
        Assert.assertEquals(encPrBase, expPrBase, "Verificação do campo pr. base, após adicionar o carum na receita região");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do campo quantidade=, após adicionar o carum na receita região");
        Assert.assertEquals(encQuantBruta, expQuantBruta, "Verificação do campo quantidade bruta, após adicionar o carum na receita região");
        Assert.assertEquals(encGanhoCoccao, expGanhoCoccao, "Verificação do campo ganho cocção, após adicionar o carum na receita região");
        Assert.assertEquals(encApCoccao, expApCoccao, "Verificação do campo ap. cocção, após adicionar o carum na receita região");
        Assert.assertEquals(encPerdaLimpeza, expPerdaLimpeza, "Verificação do campo perda limpeza, após adicionar o carum na receita região");
        Assert.assertEquals(encApLimpeza, expApLimpeza, "Verificação do campo ap. limpeza, após adicionar o carum na receita região");
        click(botaoCancelar);
    }

    public void adicionarCarumRegiaoCamposVazios() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagens de campo obrigatório
        String produto = getText(mensagemObrigatorioProdutoRegiao);
        String unidade = getText(mensagemObrigatorioUnidadeRegiao);
        String quantidade = getText(mensagemObrigatorioQuantidadeRegiao);
        String quantBruta = getText(mensagemObrigatorioQuantBrutaRegiao);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produto, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo produto da receita região");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo unidade da receita região");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo quantidade da receita região");
        Assert.assertEquals(quantBruta, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo quantidade bruta da receita região");

        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(botaoCampoProduto), 0, 10).click().build().perform();
        sendKeys(campoProcurar, "CARUM CARVI (FRUTO)");
        click(produtoCarum);
        actions.moveToElement(driver.findElement(campoQuantBrutaRegiao), -100, 0).click().build().perform();
        sendKeys(campoQuantBrutaRegiao, "1,8");
        click(botaoSalvar);
    }

    public void editarProdutoCarumRegiao() {
        tempo();
        click(produtoCarumDadoReceita);
        click(botaoEditar);
        clear(campoQuantBrutaRegiao);
        sendKeys(campoQuantBrutaRegiao, "2,8");
        click(botaoSalvar);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deseja realizar alteração proporcional?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após realizar a edição da quantidade do produto CARUM");
        click(botaoSim);
    }

    public void calcularQuantidadePessoaRegiao() {
        tempo();
        click(abaDadosDaReceitaRegiao);
        click(botaoCalcularReceitaRegiao);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Peso calculado do prato é 2.8. Confirma?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular");
        click(botaoSim);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida após clicar no botão calcular e confirmar o peso calculado");
        click(botaoSim);
        click(abaProdutosDaReceitaRegiao);
    }

    public void editarDadosReceitaRegiao() {
        click(abaDadosDaReceitaRegiao);
        click(botaoEditar);
        clear(campoQuantidadePessoaRegiao);
        sendKeys(campoQuantidadePessoaRegiao, "1,2");
        click(campoDataInativacaoAutoRegiao);
        sendKeys(campoDataInativacaoAutoRegiao, "05/07/2022");
        click(botaoSalvar);
        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Só é possível informar uma data para inativação maior que a data atual.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após inserir uma data antes da atual");
        click(botaoOkAlerta);

        clear(campoDataInativacaoAutoRegiao);
        click(campoDataInativacaoAutoRegiao);
        sendKeys(campoDataInativacaoAutoRegiao, "05/07/2031");
        click(botaoSalvar);

        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Deseja alterar proporcionalmente as quantidades dos produtos na receita?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após alterar o valor do campo quantidade/pessoa");
        click(botaoSim);
    }

    public void verificarEdicaoDadosReceitaRegiao() {
        click(abaDadosDaReceitaRegiao);
        click(botaoEditar);

        //valores encontrados
        String encQuantidadePessoa = driver.findElement(campoQuantidadePessoaRegiao).getAttribute("value");
        String encDataInativacaoAuto = driver.findElement(campoDataInativacaoAutoRegiao).getAttribute("value");

        //valores esperados
        String expQuantidadePessoa = "1,20000";
        String expDataInativacaoAuto = "05/07/2031";
        Assert.assertEquals(encQuantidadePessoa, expQuantidadePessoa, "Verificação do campo quantidade por pessoa após a edição dos dados da receita região");
        Assert.assertEquals(encDataInativacaoAuto, expDataInativacaoAuto, "Verificação do campo data inativação automática após a edição dos dados da receita região");
        tempo();
        click(botaoCancelar);
        click(abaProdutosDaReceitaRegiao);
    }

    public void desfazerEdicaoDadosReceitaRegiao() {
        click(abaDadosDaReceitaRegiao);
        click(botaoEditar);
        clear(campoQuantidadePessoaRegiao);
        click(botaoDataInativacaoRegiao);
        click(botaoSalvar);
        click(abaProdutosDaReceitaRegiao);
    }

    public void excluirProdutoCarum(String receita) {
        tempo();
        click(produtoCarumDadoReceita);
        tempo();
        click(botaoExcluir);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem que é exbida após clicar no botão excluir de algum produto da receita");
        click(botaoSim);

        if (receita != "Padrão") {
            mensagemAlerta = getText(mensagemNaoHaRegistro);
            mensagemEsperada = "Não há registros";
            Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Mensagem esperada informando que não há registro");
        }
    }

    public void selecReceita(String receita) {
        if (receita == "Padrão") {
            clicarCampoSelecionarValor(abaReceita, receitaPadrao);
        } else if (receita == "Local") {
            clicarCampoSelecionarValor(abaReceita, receitaLocal);
        } else if (receita == "Serviço") {
            clicarCampoSelecionarValor(abaReceita, receitaServico);
            clicarCampoSelecionarValor(campoServico, servicoJantaReceitaServico);
        } else if (receita == "Padrão de Qualidade") {
            clicarCampoSelecionarValor(abaReceita, receitaPadraoQualidade);
            clicarCampoSelecionarValor(campoPadraoQualidade, padraoQualidadeExcelenteReceita);
        } else if (receita == "Região") {
            clicarCampoSelecionarValor(abaReceita, receitaRegiao);
            clicarCampoSelecionarValor(campoPadraoQualidade, regionalQualidadeExcelenteReceita);
            tempo();

            WebElement element = driver.findElement(campoRegiao);
            Actions actions = new Actions(driver);
            actions.moveToElement(element, -200, 0);
            actions.click().build().perform();
            click(regiaoBeloHorizonteReceita);
        }
    }

    public void selecModoPreparo(String receita) {
        if (receita == "Padrão") {
            clicarCampoSelecionarValor(abaModoPreparo, receitaPadrao);
        } else if (receita == "Local") {
            clicarCampoSelecionarValor(abaModoPreparo, receitaLocal);
        } else if (receita == "Serviço") {
            clicarCampoSelecionarValor(abaModoPreparo, receitaServico);
            clicarCampoSelecionarValor(campoServico, servicoJantaModoPreparo);
        } else if (receita == "Padrão de Qualidade") {
            clicarCampoSelecionarValor(abaModoPreparo, receitaPadraoQualidade);
            clicarCampoSelecionarValor(campoPadraoQualidade, padraoQualidadeExcelenteModoPreparo);
        } else if (receita == "Região") {
            clicarCampoSelecionarValor(abaModoPreparo, receitaRegiao);
            clicarCampoSelecionarValor(campoPadraoQualidade, regionalQualidadeExcelenteModoPreparo);

            tempo();
            WebElement element = driver.findElement(campoRegiao);
            Actions actions = new Actions(driver);
            actions.moveToElement(element, -200, 0);
            actions.click().build().perform();
            click(regiaoBeloHorizonteModoPreparo);
        }
    }

    public void adicionarModoPreparoPadrao() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoStatusPadrao, statusAtivoPadrao);
        sendKeys(campoResponsavelPadrao, "Teste automatizado");
        sendKeys(campoTextoPadrao, "Modo de preparo, elaborado pelo teste automatizado");
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encStatus = getText(checarStatusPreparoPadrao);
        String encResponsavel = getText(checarResponsavelPreparoPadrao);
        String encTexto = getText(checarTextoPreparoPadrao);

        //valores esperados
        String expStatus = "Ativo";
        String expResponsavel = "Teste automatizado";
        String expTexto = "Modo de preparo, elaborado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void adicionarModoPreparoLocal() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoStatusLocal, statusAtivoLocal);
        sendKeys(campoResponsavelLocal, "Teste automatizado");
        sendKeys(campoTextoLocal, "Modo de preparo, elaborado pelo teste automatizado");
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encStatus = getText(checarStatusPreparoLocal);
        String encResponsavel = getText(checarResponsavelPreparoLocal);
        String encTexto = getText(checarTextoPreparoLocal);

        //valores esperados
        String expStatus = "Ativo";
        String expResponsavel = "Teste automatizado";
        String expTexto = "Modo de preparo, elaborado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void adicionarModoPreparoServico() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoStatusServico, statusAtivoServico);
        sendKeys(campoResponsavelServico, "Teste automatizado");
        sendKeys(campoTextoServico, "Modo de preparo, elaborado pelo teste automatizado");
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encStatus = getText(checarStatusPreparoServico);
        String encResponsavel = getText(checarResponsavelPreparoServico);
        String encTexto = getText(checarTextoPreparoServico);

        //valores esperados
        String expStatus = "Ativo";
        String expResponsavel = "Teste automatizado";
        String expTexto = "Modo de preparo, elaborado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado na receita por serviço");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado na receita por serviço");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado na receita por serviço");
    }

    public void adicionarModoPreparoPadraoQualidade() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoStatusPadraQualidade, statusAtivoPadraoQualidade);
        sendKeys(campoResponsavelPadraoQualidade, "Teste automatizado");
        sendKeys(campoTextoPadraoQualidade, "Modo de preparo, elaborado pelo teste automatizado");
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encStatus = getText(checarStatusPreparoPadraoQualidade);
        String encResponsavel = getText(checarResponsavelPreparoPadraoQualidade);
        String encTexto = getText(checarTextoPreparoPadraoQualidade);

        //valores esperados
        String expStatus = "Ativo";
        String expResponsavel = "Teste automatizado";
        String expTexto = "Modo de preparo, elaborado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado na receita por serviço");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado na receita por serviço");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado na receita por serviço");
    }

    public void adicionarModoPreparoRegiao() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoStatusRegiao, statusAtivoRegiao);
        sendKeys(campoResponsavelRegiao, "Teste automatizado");
        sendKeys(campoTextoRegiao, "Modo de preparo, elaborado pelo teste automatizado");
        click(botaoSalvar);
        tempo();

        //valores encontrados
        String encStatus = getText(checarStatusPreparoRegiao);
        String encResponsavel = getText(checarResponsavelPreparoRegiao);
        String encTexto = getText(checarTextoPreparoRegiao);

        //valores esperados
        String expStatus = "Ativo";
        String expResponsavel = "Teste automatizado";
        String expTexto = "Modo de preparo, elaborado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado na receita por serviço");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado na receita por serviço");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado na receita por serviço");
    }

    public void editarModoPreparoPadrao() {
        tempo();
        click(checarStatusPreparoPadrao);
        click(botaoEditar);
        clicarCampoSelecionarValor(campoStatusPadrao, statusInativoPadrao);
        clear(campoResponsavelPadrao);
        sendKeys(campoResponsavelPadrao, "Automatizado");
        clear(campoTextoPadrao);
        sendKeys(campoTextoPadrao, "Modo de preparo, editado pelo teste automatizado");
        click(botaoSalvar);

        //valores encontrados
        String encStatus = getText(checarStatusPreparoPadrao);
        String encResponsavel = getText(checarResponsavelPreparoPadrao);
        String encTexto = getText(checarTextoPreparoPadrao);

        //valores esperados
        String expStatus = "Inativo";
        String expResponsavel = "Automatizado";
        String expTexto = "Modo de preparo, editado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void editarModoPreparoLocal() {
        tempo();
        click(checarStatusPreparoLocal);
        click(botaoEditar);
        clicarCampoSelecionarValor(campoStatusLocal, statusInativoLocal);
        clear(campoResponsavelLocal);
        sendKeys(campoResponsavelLocal, "Automatizado");
        clear(campoTextoLocal);
        sendKeys(campoTextoLocal, "Modo de preparo, editado pelo teste automatizado");
        click(botaoSalvar);

        //valores encontrados
        String encStatus = getText(checarStatusPreparoLocal);
        String encResponsavel = getText(checarResponsavelPreparoLocal);
        String encTexto = getText(checarTextoPreparoLocal);

        //valores esperados
        String expStatus = "Inativo";
        String expResponsavel = "Automatizado";
        String expTexto = "Modo de preparo, editado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void editarModoPreparoServico() {
        tempo();
        click(checarStatusPreparoServico);
        click(botaoEditar);
        clicarCampoSelecionarValor(campoStatusServico, statusInativoServico);
        clear(campoResponsavelServico);
        sendKeys(campoResponsavelServico, "Automatizado");
        clear(campoTextoServico);
        sendKeys(campoTextoServico, "Modo de preparo, editado pelo teste automatizado");
        click(botaoSalvar);

        //valores encontrados
        String encStatus = getText(checarStatusPreparoServico);
        String encResponsavel = getText(checarResponsavelPreparoServico);
        String encTexto = getText(checarTextoPreparoServico);

        //valores esperados
        String expStatus = "Inativo";
        String expResponsavel = "Automatizado";
        String expTexto = "Modo de preparo, editado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void editarModoPreparoPadraoQualidade() {
        tempo();
        click(checarStatusPreparoPadraoQualidade);
        click(botaoEditar);
        clicarCampoSelecionarValor(campoStatusPadraQualidade, statusInativoPadraoQualidade);
        clear(campoResponsavelPadraoQualidade);
        sendKeys(campoResponsavelPadraoQualidade, "Automatizado");
        clear(campoTextoPadraoQualidade);
        sendKeys(campoTextoPadraoQualidade, "Modo de preparo, editado pelo teste automatizado");
        click(botaoSalvar);

        //valores encontrados
        String encStatus = getText(checarStatusPreparoPadraoQualidade);
        String encResponsavel = getText(checarResponsavelPreparoPadraoQualidade);
        String encTexto = getText(checarTextoPreparoPadraoQualidade);

        //valores esperados
        String expStatus = "Inativo";
        String expResponsavel = "Automatizado";
        String expTexto = "Modo de preparo, editado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void editarModoPreparoRegiao() {
        tempo();
        click(checarStatusPreparoRegiao);
        click(botaoEditar);
        clicarCampoSelecionarValor(campoStatusRegiao, statusInativoRegiao);
        clear(campoResponsavelRegiao);
        sendKeys(campoResponsavelRegiao, "Automatizado");
        clear(campoTextoRegiao);
        sendKeys(campoTextoRegiao, "Modo de preparo, editado pelo teste automatizado");
        click(botaoSalvar);

        //valores encontrados
        String encStatus = getText(checarStatusPreparoRegiao);
        String encResponsavel = getText(checarResponsavelPreparoRegiao);
        String encTexto = getText(checarTextoPreparoRegiao);

        //valores esperados
        String expStatus = "Inativo";
        String expResponsavel = "Automatizado";
        String expTexto = "Modo de preparo, editado pelo teste automatizado";

        Assert.assertEquals(encStatus, expStatus, "Verificação do status do modo de preparo adicionado");
        Assert.assertEquals(encResponsavel, expResponsavel, "Verificação do responsável do modo de preparo adicionado");
        Assert.assertEquals(encTexto, expTexto, "Verificação do texto do modo de preparo adicionado");
    }

    public void excluirModoPreparo(String tipoReceita) {
        tempo();
        if (tipoReceita == "Padrão") {
            click(checarStatusPreparoPadrao);
        } else if (tipoReceita == "Local") {
            click(checarStatusPreparoLocal);
        } else if (tipoReceita == "Serviço") {
            click(checarStatusPreparoServico);
        } else if (tipoReceita == "Padrão de Qualidade") {
            click(checarStatusPreparoPadraoQualidade);
        } else if (tipoReceita == "Região") {
            click(checarStatusPreparoRegiao);
        }
        click(botaoExcluir);

        String mensagemEncontrada = getText(campoMensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagemEncontrada, mensagemEsperada, "Verificação da mensagem após clicar para excluir um modo de preparo");
        click(botaoSim);

        mensagemEncontrada = getText(campoMensagemAlerta);
        mensagemEsperada = "Modo de preparo excluído com sucesso!";
        Assert.assertEquals(mensagemEncontrada, mensagemEsperada, "Verificação da mensagem de sucesso exbida após excluir um modo de preparo");
        click(botaoOkAlerta);

        mensagemEncontrada = getText(mensagemNaoHaRegistro);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagemEncontrada, mensagemEsperada, "Verificação da mensagem de não há registro após excluir um modo de preparo");
    }

    public void produtoProducaoRepetido(String receita) {
        if (receita == "Padrão") {
            click(abaDadosDaReceitaPadrao);
            click(botaoEditar);
//            click(botaoCampoProduto);
            click(botaoCampoProduto);
            click(produtoBarataOriental);
        } else if (receita == "Local") {
            click(abaDadosDaReceitaLocal);
            click(botaoEditar);
            click(botaoCampoProduto);
//            click(botaoCampoProduto);
            click(produtoBarataOriental);
        } else if (receita == "Serviço") {
            click(abaDadosDaReceitaServico);
            click(botaoEditar);
            click(botaoCampoProduto);
            click(produtoBarataOriental);
        }
        click(botaoSalvar);

        String mensagemAlertaCompleta = getText(campoMensagemAlerta);
        String inicioMensagemEncontrado = mensagemAlertaCompleta.substring(0, 71);
        String inicioMensagemEsperado = "O produto de produção já está sendo usado na(s) seguinte(s) receita(s):";
        Assert.assertEquals(inicioMensagemEncontrado, inicioMensagemEsperado, "Verificação da parte inicial da mensagem de alerta informando que o produto de produção já está sendo usado");

        String finalMensagemEncontrado = mensagemAlertaCompleta.substring(mensagemAlertaCompleta.length() - 70);
        String finalMensagemEsperado = "Realize a importaçao da receita para utilização deste produto acabado.";
        Assert.assertEquals(finalMensagemEncontrado, finalMensagemEsperado, "Verificação da parte final da mensagem de alerta informando que o produto de produção já está sendo usado");
        click(botaoOkAlerta);
    }

    public void aproveitamentoCoccaoELimpezaVazios(String receita) {
        String mensagemAlerta = "";
        String mensagemEsperada = "";
        click(botaoAdicionar);
        if (receita == "Padrão") {
            clear(campoApCoccaoPadrao);
        } else if (receita == "Local") {
            clear(campoApCoccaoLocal);
        } else if (receita == "Serviço") {
            clear(campoApCoccaoServico);
        } else if (receita == "Padrão de Qualidade") {
            clear(campoApCoccaoPadraoQualidade);
        } else if (receita == "Região") {
            clear(campoApCoccaoRegiao);
        }
        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "Aprovação de Cocção deve ser maior que 0,00";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após deixar o campo ap.cocção vazio");
        click(botaoOkAlerta);

        if (receita == "Padrão") {
            clear(campoApLimpezaPadrao);
        } else if (receita == "Local") {
            clear(campoApLimpezaLocal);
        } else if (receita == "Serviço") {
            clear(campoApLimpezaServico);
        } else if (receita == "Padrão de Qualidade") {
            clear(campoApLimpezaPadraoQualidade);
        } else if (receita == "Região") {
            clear(campoApLimpezaCoccaoRegiao);
        }
        mensagemAlerta = getText(campoMensagemAlerta);
        mensagemEsperada = "A aprovação da perda da limpeza deve estar entre 1% e 100%";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta após deixar o campo ap.limpeza vazio");
        click(botaoOkAlerta);
    }

    public void consultarNutrienteReceita() {
        click(botaoAcoes);
        click(acaoConsultarNutrientes);

        //valores encontrados que dão nome para as colunas que iram apresentar os valores dos nutrientes
        String encCodigo = getText(consultarColunaCodNutriente);
        String encNome = getText(consultarColunaNomeNutriente);
        String encUnidade = getText(consultarColunaUnidadeNutriente);
        String encQuantidade = getText(consultarColunaQuantNutriente);

        //valores esperados para o nome das colunas
        String expCodigo = "Código";
        String expNome = "Nome";
        String expUnidade = "UN";
        String expQuantidade = "Quantidade";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do nome da primeira coluna com os dados dos nutrientes");
        Assert.assertEquals(encNome, expNome, "Verificação do nome da segunda coluna com os dados dos nutrientes");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação do nome da terceira coluna com os dados dos nutrientes");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação do nome da quarta coluna com os dados dos nutrientes");
        click(botaoVoltar);
    }

    public void acessarPratoSaladaAlface() {
        tempo();
        tempo();
        click(botaoMenuOpcoesTelaPrato);
        click(botaoPesquisarPrato);
        sendKeys(campoProcurar, "SALADA DE ALFACE");
        click(pratoSaladaAlface);
        click(abaReceita);
    }

    public void alterarFinalizacao(String receita) {
        if (receita == "Padrão") click(abaDadosDaReceitaPadrao);
        else if (receita == "Local") click(abaDadosDaReceitaLocal);
        else if (receita == "Serviço") click(abaDadosDaReceitaServico);

        selecionaFinalizacaoUnidade(receita);
        tempo();
        tempo();
        selecionaFinalizacaoMatriz(receita);
    }

    private void selecionaFinalizacaoUnidade(String receita) {
        click(botaoEditar);
        if (receita == "Padrão") clicarCampoSelecionarValor(campoFinalizacaoPadrao, finalizacaoUnidadePadrao);
        else if (receita == "Local") clicarCampoSelecionarValor(campoFinalizacaoLocal, finalizacaoUnidadeLocal);
        else if (receita == "Serviço") clicarCampoSelecionarValor(campoFinalizacaoServico, finalizacaoUnidadeServico);
        click(botaoSalvar);
        verificarMensagemAlteradoSucesso();
    }

    private void selecionaFinalizacaoMatriz(String receita) {
        click(botaoEditar);
        if (receita == "Padrão") clicarCampoSelecionarValor(campoFinalizacaoPadrao, finalizacaoMatrizPadrao);
        else if (receita == "Local") clicarCampoSelecionarValor(campoFinalizacaoLocal, finalizacaoMatrizLocal);
        else if (receita == "Serviço") clicarCampoSelecionarValor(campoFinalizacaoServico, finalizacaoMatrizServico);
        click(botaoSalvar);
        verificarMensagemAlteradoSucesso();
    }

    private void verificarMensagemAlteradoSucesso() {
        String mensagemSucessoEncontrada = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagemSucessoEncontrada, mensagemEsperada, "Verificação da mensagem exibida após salvar a alteração do campo 'finalização'");
    }

    public void tentarAlterarRecComProdPadrRepetido() {
        click(botaoAdicionar);
        String mensagemAlertaEncontrada = getText(campoMensagemAlerta);
        String mensagemEsperada = "Receita não pode ser alterada pois o produto de produção já existe em outra receita.";
        Assert.assertEquals(mensagemAlertaEncontrada, mensagemEsperada, "Verificação da mensagem exibida na tela informando que não é possível " +
                "alterar a receita por o prod. produção, também é usado em outra receita. Verificação após clicar no botão adicionar");
        click(botaoOkAlerta);

        click(produtoQuerosene);
        click(botaoExcluir);
        mensagemAlertaEncontrada = getText(campoMensagemAlerta);
        mensagemEsperada = "Receita não pode ser excluida pois o produto de produção já existe em outra receita.";
        Assert.assertEquals(mensagemAlertaEncontrada, mensagemEsperada, "Verificação da mensagem exibida na tela informando que não é possível " +
                "alterar a receita por o prod. produção, também é usado em outra receita. Verificação após tentar excluir um produto da receita");
        click(botaoOkAlerta);
        click(botaoVoltar);
    }

}